/**************************************************************************/
/*                                                                        */
/*  Dc_CPU.h :  Header pour la bibliothque de gestion du Microprocessor. */
/*                                                                        */
/**************************************************************************/
/*  Auteur : Olivier ZARDINI  *   Brutal Deluxe Software   *  Avril 2018  */
/**************************************************************************/

#define CPU_REGISTER_A             10
#define CPU_REGISTER_X             11
#define CPU_REGISTER_Y             12
#define CPU_REGISTER_DBR           13
#define CPU_REGISTER_PBR           14
#define CPU_REGISTER_PC            15
#define CPU_REGISTER_STACK         16
#define CPU_REGISTER_DIRECTPAGE    17

#define CPU_STATUS_C               20
#define CPU_STATUS_Z               21
#define CPU_STATUS_I               22
#define CPU_STATUS_D               23
#define CPU_STATUS_X               24
#define CPU_STATUS_M               25
#define CPU_STATUS_V               26
#define CPU_STATUS_N               27
#define CPU_STATUS_E               28
#define CPU_STATUS_B               29

#define CPU_ADDRESS_STACK          30
#define CPU_ADDRESS_DIRECTPAGE     31
#define CPU_BANK_DIRECTPAGE_STACK  32
#define CPU_ADDRESS_SOFTSWITCH     33

struct cpu
{
  /* Register */
  WORD proc_a;
  WORD proc_x;
  WORD proc_y;
  BYTE proc_dbr;
  BYTE proc_pbr;
  WORD proc_pc;
  WORD proc_stack;
  WORD proc_directpage;

  /* Status Register */
  int status_c;
  int status_z;
  int status_i;
  int status_d;
  int status_x;
  int status_m;
  int status_v;
  int status_n;
  int status_e;
  int status_b;
  
  /* Banc de la Page Directe et de la Stack */
  BYTE directpage_stack_bank;    /* $00/ ou $01/ */
};

int GetCPUData(int,struct cpu *);
void SetCPUData(int,int,struct cpu *);

/**************************************************************************/
