/************************************************************************/
/*                                                                      */
/*  Dc_Graphic.h :  Header pour la bibliothque de gestion des Graphic. */
/*                                                                      */
/************************************************************************/
/*  Auteur : Olivier ZARDINI  *  Brutal Deluxe Software  *  Avril 2018  */
/************************************************************************/

struct picture_true
{
  int width;
  int height;

  DWORD *data_dwd;
  unsigned char *data;

  /* Palette de l'image */
  int nb_color;

  /* RGB */
  int palette_red[256];
  int palette_green[256];
  int palette_blue[256];
};

struct picture_256
{
  char format[256];    /* Format d'origine */

  int width;
  int height;

  int color_depth;     /* Profondeur de couleurs de la palette : 16M, 16K ou 4096 */

  /* Nombre de pixels de l'image (width*height - # background_pixel) */
  int nb_pixel;

  /* Palette de l'image */
  int nb_color;

  /* RGB */
  int palette_red[256];
  int palette_green[256];
  int palette_blue[256];
  DWORD palette_rgb[256];

  /* HSL */
  int palette_h[256];    /* Teinte */
  int palette_s[256];    /* Saturation */
  int palette_l[256];    /* Lumience */

  unsigned char *data;

  /* Stat */
  int max_color_line;     /* Nombre Max de couleur sur 1 ligne */
  int *tab_nb_color;      /* Nombre de couleur sur la ligne (dimension = height) */
  int color_usage[256];   /* Utilisation des couleurs dans l'image */
  int *tab_color_line;    /* Utilisation des couleurs pour chaque ligne (dimension = height*256)*/
};

struct picture_true *GetPictureFromResource(int resource_id);
struct picture_256 *ConvertTrueColorTo256(struct picture_true *);
void mem_free_picture_true(struct picture_true *);
void mem_free_picture_256(struct picture_256 *);

/************************************************************************/
