/************************************************************************/
/*                                                                      */
/*  Dc_Memory.h :  Header pour la bibliothque de gestion Mmoire.      */
/*                                                                      */
/************************************************************************/
/*  Auteur : Olivier ZARDINI  *  Brutal Deluxe Software  *  Avril 2018  */
/************************************************************************/

#define MEMORY_INIT_ALL                   10
#define MEMORY_FREE_ALL                   11

#define MEMORY_SET_PARAM                  20
#define MEMORY_GET_PARAM                  21
#define MEMORY_FREE_PARAM                 22

#define MEMORY_SET_SNAPSHOT               40
#define MEMORY_GET_SNAPSHOT               41
#define MEMORY_FREE_SNAPSHOT              42

#define MEMORY_SET_S65816                 50
#define MEMORY_GET_S65816                 51
#define MEMORY_GET_S65816_CPU             52
#define MEMORY_GET_S65816_MMU             53
#define MEMORY_FREE_S65816                54

#define MEMORY_INIT_REQUEST               70        /* Liste des Requtes */
#define MEMORY_ADD_REQUEST                71
#define MEMORY_GET_REQUEST_NB             72
#define MEMORY_GET_REQUEST                73
#define MEMORY_EXTRACT_REQUEST            74
#define MEMORY_FREE_REQUEST               76

#define MEMORY_INIT_OPERATION             80        /* Liste des Operations */
#define MEMORY_ADD_OPERATION              81
#define MEMORY_ADD_EXTRA_OPERATION        82
#define MEMORY_GET_OPERATION_NB           83
#define MEMORY_GET_OPERATION              84
#define MEMORY_FREE_EXTRA_OPERATION       85
#define MEMORY_FREE_OPERATION             86

#define MEMORY_INIT_FILE                 100
#define MEMORY_ADD_FILE                  101
#define MEMORY_GET_FILE_NB               102
#define MEMORY_GET_FILE                  103
#define MEMORY_SORT_FILE                 104
#define MEMORY_SORT_FILE_BY_SIZE         105
#define MEMORY_FREE_FILE                 106

#define MEMORY_CLOSE_WINDOW_ALL          999

#define MEMORY_SET_WINDOW_MAIN          1000
#define MEMORY_GET_WINDOW_MAIN          1001
#define MEMORY_FREE_WINDOW_MAIN         1002

#define MEMORY_SET_WINDOW_IPC           1005
#define MEMORY_GET_WINDOW_IPC           1006
#define MEMORY_FREE_WINDOW_IPC          1007

#define MEMORY_SET_WINDOW_ABOUT         1010
#define MEMORY_GET_WINDOW_ABOUT         1011
#define MEMORY_CLOSE_WINDOW_ABOUT       1012
#define MEMORY_FREE_WINDOW_ABOUT        1013

#define MEMORY_SET_WINDOW_STACK         1040
#define MEMORY_GET_WINDOW_STACK         1041
#define MEMORY_CLOSE_WINDOW_STACK       1042
#define MEMORY_FREE_WINDOW_STACK        1043

#define MEMORY_SET_WINDOW_DIRECTPAGE    1050
#define MEMORY_GET_WINDOW_DIRECTPAGE    1051
#define MEMORY_CLOSE_WINDOW_DIRECTPAGE  1052
#define MEMORY_FREE_WINDOW_DIRECTPAGE   1053

#define MEMORY_SET_WINDOW_SOFTSWITCH    1060
#define MEMORY_GET_WINDOW_SOFTSWITCH    1061
#define MEMORY_CLOSE_WINDOW_SOFTSWITCH  1062
#define MEMORY_FREE_WINDOW_SOFTSWITCH   1063

#define MEMORY_SET_WINDOW_PROCESSOR     1070
#define MEMORY_GET_WINDOW_PROCESSOR     1071
#define MEMORY_CLOSE_WINDOW_PROCESSOR   1072
#define MEMORY_FREE_WINDOW_PROCESSOR    1073

#define MEMORY_ADD_WINDOW_MEMORYAREA    1080
#define MEMORY_GET_WINDOW_MEMORYAREA    1081
#define MEMORY_DELETE_WINDOW_MEMORYAREA 1082
#define MEMORY_CLOSE_WINDOW_MEMORYAREA  1083
#define MEMORY_FREE_WINDOW_MEMORYAREA   1084

#define MEMORY_ADD_WINDOW_RAMSOUND      1090
#define MEMORY_GET_WINDOW_RAMSOUND      1091
#define MEMORY_DELETE_WINDOW_RAMSOUND   1092
#define MEMORY_CLOSE_WINDOW_RAMSOUND    1093
#define MEMORY_FREE_WINDOW_RAMSOUND     1094

#define MEMORY_ADD_WINDOW_TEXTPAGE40    1100
#define MEMORY_GET_WINDOW_TEXTPAGE40    1101
#define MEMORY_DELETE_WINDOW_TEXTPAGE40 1102
#define MEMORY_CLOSE_WINDOW_TEXTPAGE40  1103
#define MEMORY_FREE_WINDOW_TEXTPAGE40   1104

#define MEMORY_ADD_WINDOW_TEXTPAGE80    1110
#define MEMORY_GET_WINDOW_TEXTPAGE80    1111
#define MEMORY_DELETE_WINDOW_TEXTPAGE80 1112
#define MEMORY_CLOSE_WINDOW_TEXTPAGE80  1113
#define MEMORY_FREE_WINDOW_TEXTPAGE80   1114

#define MEMORY_ADD_WINDOW_GRAPHICGR     1120
#define MEMORY_GET_WINDOW_GRAPHICGR     1121
#define MEMORY_DELETE_WINDOW_GRAPHICGR  1122
#define MEMORY_CLOSE_WINDOW_GRAPHICGR   1123
#define MEMORY_FREE_WINDOW_GRAPHICGR    1124

#define MEMORY_ADD_WINDOW_GRAPHICHGR    1200
#define MEMORY_GET_WINDOW_GRAPHICHGR    1201
#define MEMORY_DELETE_WINDOW_GRAPHICHGR 1202
#define MEMORY_CLOSE_WINDOW_GRAPHICHGR  1203
#define MEMORY_FREE_WINDOW_GRAPHICHGR   1204

#define MEMORY_ADD_WINDOW_GRAPHICDHGRMONO     1300
#define MEMORY_GET_WINDOW_GRAPHICDHGRMONO     1301
#define MEMORY_DELETE_WINDOW_GRAPHICDHGRMONO  1302
#define MEMORY_CLOSE_WINDOW_GRAPHICDHGRMONO   1303
#define MEMORY_FREE_WINDOW_GRAPHICDHGRMONO    1304

#define MEMORY_ADD_WINDOW_GRAPHICDHGRCOLOR    1310
#define MEMORY_GET_WINDOW_GRAPHICDHGRCOLOR    1311
#define MEMORY_DELETE_WINDOW_GRAPHICDHGRCOLOR 1312
#define MEMORY_CLOSE_WINDOW_GRAPHICDHGRCOLOR  1313
#define MEMORY_FREE_WINDOW_GRAPHICDHGRCOLOR   1314

#define MEMORY_ADD_WINDOW_GRAPHICDGR      1320
#define MEMORY_GET_WINDOW_GRAPHICDGR      1321
#define MEMORY_DELETE_WINDOW_GRAPHICDGR   1322
#define MEMORY_CLOSE_WINDOW_GRAPHICDGR    1323
#define MEMORY_FREE_WINDOW_GRAPHICDGR     1324

#define MEMORY_ADD_WINDOW_GRAPHICHGRTEXT40      1330
#define MEMORY_GET_WINDOW_GRAPHICHGRTEXT40      1331
#define MEMORY_DELETE_WINDOW_GRAPHICHGRTEXT40   1332
#define MEMORY_CLOSE_WINDOW_GRAPHICHGRTEXT40    1333
#define MEMORY_FREE_WINDOW_GRAPHICHGRTEXT40     1334

#define MEMORY_ADD_WINDOW_GRAPHICHGRTEXT80      1340
#define MEMORY_GET_WINDOW_GRAPHICHGRTEXT80      1341
#define MEMORY_DELETE_WINDOW_GRAPHICHGRTEXT80   1342
#define MEMORY_CLOSE_WINDOW_GRAPHICHGRTEXT80    1343
#define MEMORY_FREE_WINDOW_GRAPHICHGRTEXT80     1344

#define MEMORY_ADD_WINDOW_GRAPHICGRTEXT40      1350
#define MEMORY_GET_WINDOW_GRAPHICGRTEXT40      1351
#define MEMORY_DELETE_WINDOW_GRAPHICGRTEXT40   1352
#define MEMORY_CLOSE_WINDOW_GRAPHICGRTEXT40    1353
#define MEMORY_FREE_WINDOW_GRAPHICGRTEXT40     1354

#define MEMORY_ADD_WINDOW_GRAPHICGRTEXT80      1360
#define MEMORY_GET_WINDOW_GRAPHICGRTEXT80      1361
#define MEMORY_DELETE_WINDOW_GRAPHICGRTEXT80   1362
#define MEMORY_CLOSE_WINDOW_GRAPHICGRTEXT80    1363
#define MEMORY_FREE_WINDOW_GRAPHICGRTEXT80     1364

#define MEMORY_ADD_WINDOW_GRAPHICDGRTEXT80      1370
#define MEMORY_GET_WINDOW_GRAPHICDGRTEXT80      1371
#define MEMORY_DELETE_WINDOW_GRAPHICDGRTEXT80   1372
#define MEMORY_CLOSE_WINDOW_GRAPHICDGRTEXT80    1373
#define MEMORY_FREE_WINDOW_GRAPHICDGRTEXT80     1374

#define MEMORY_ADD_WINDOW_GRAPHICDHGRMONOTEXT80      1380
#define MEMORY_GET_WINDOW_GRAPHICDHGRMONOTEXT80      1381
#define MEMORY_DELETE_WINDOW_GRAPHICDHGRMONOTEXT80   1382
#define MEMORY_CLOSE_WINDOW_GRAPHICDHGRMONOTEXT80    1383
#define MEMORY_FREE_WINDOW_GRAPHICDHGRMONOTEXT80     1384

#define MEMORY_ADD_WINDOW_GRAPHICDHGRCOLORTEXT80     1390
#define MEMORY_GET_WINDOW_GRAPHICDHGRCOLORTEXT80     1391
#define MEMORY_DELETE_WINDOW_GRAPHICDHGRCOLORTEXT80  1392
#define MEMORY_CLOSE_WINDOW_GRAPHICDHGRCOLORTEXT80   1393
#define MEMORY_FREE_WINDOW_GRAPHICDHGRCOLORTEXT80    1394

#define MEMORY_ADD_WINDOW_GRAPHICSHR            1400
#define MEMORY_GET_WINDOW_GRAPHICSHR            1401
#define MEMORY_DELETE_WINDOW_GRAPHICSHR         1402
#define MEMORY_CLOSE_WINDOW_GRAPHICSHR          1403
#define MEMORY_FREE_WINDOW_GRAPHICSHR           1404

#define MEMORY_ADD_WINDOW_DISASSEMBLER          1410
#define MEMORY_GET_WINDOW_DISASSEMBLER          1411
#define MEMORY_DELETE_WINDOW_DISASSEMBLER       1412
#define MEMORY_CLOSE_WINDOW_DISASSEMBLER        1413
#define MEMORY_FREE_WINDOW_DISASSEMBLER         1414

#define MEMORY_SET_WINDOW_MEMORYMAP             1420
#define MEMORY_GET_WINDOW_MEMORYMAP             1421
#define MEMORY_CLOSE_WINDOW_MEMORYMAP           1422
#define MEMORY_FREE_WINDOW_MEMORYMAP            1423

#define MEMORY_SET_WINDOW_DOCREGISTER           1430
#define MEMORY_GET_WINDOW_DOCREGISTER           1431
#define MEMORY_CLOSE_WINDOW_DOCREGISTER         1432
#define MEMORY_FREE_WINDOW_DOCREGISTER          1433

#define MEMORY_SET_WINDOW_SEARCH                1440
#define MEMORY_GET_WINDOW_SEARCH                1441
#define MEMORY_CLOSE_WINDOW_SEARCH              1442
#define MEMORY_FREE_WINDOW_SEARCH               1443

#define MEMORY_SET_WINDOW_REPLACE               1450
#define MEMORY_GET_WINDOW_REPLACE               1451
#define MEMORY_CLOSE_WINDOW_REPLACE             1452
#define MEMORY_FREE_WINDOW_REPLACE              1453

#define MEMORY_ADD_WINDOW_LOADFILE              1460
#define MEMORY_GET_WINDOW_LOADFILE              1461
#define MEMORY_DELETE_WINDOW_LOADFILE           1462
#define MEMORY_CLOSE_WINDOW_LOADFILE            1463
#define MEMORY_FREE_WINDOW_LOADFILE             1464

#define MEMORY_ADD_WINDOW_SAVEMEMORY            1470
#define MEMORY_GET_WINDOW_SAVEMEMORY            1471
#define MEMORY_DELETE_WINDOW_SAVEMEMORY         1472
#define MEMORY_CLOSE_WINDOW_SAVEMEMORY          1473
#define MEMORY_FREE_WINDOW_SAVEMEMORY           1474

#define MEMORY_ADD_WINDOW_COMPARE               1480
#define MEMORY_GET_WINDOW_COMPARE               1481
#define MEMORY_DELETE_WINDOW_COMPARE            1482
#define MEMORY_CLOSE_WINDOW_COMPARE             1483
#define MEMORY_FREE_WINDOW_COMPARE              1484

#define MEMORY_SET_WINDOW_QUICKWATCH            1490
#define MEMORY_GET_WINDOW_QUICKWATCH            1491
#define MEMORY_DELETE_WINDOW_QUICKWATCH         1492
#define MEMORY_CLOSE_WINDOW_QUICKWATCH          1493
#define MEMORY_FREE_WINDOW_QUICKWATCH           1494

#define MEMORY_ADD_WINDOW_MODIFY                1500
#define MEMORY_GET_WINDOW_MODIFY                1501
#define MEMORY_DELETE_WINDOW_MODIFY             1502
#define MEMORY_CLOSE_WINDOW_MODIFY              1503
#define MEMORY_FREE_WINDOW_MODIFY               1504

#define MEMORY_ADD_WINDOW_MOVE                  1510
#define MEMORY_GET_WINDOW_MOVE                  1511
#define MEMORY_DELETE_WINDOW_MOVE               1512
#define MEMORY_CLOSE_WINDOW_MOVE                1513
#define MEMORY_FREE_WINDOW_MOVE                 1514

#define MEMORY_SET_WINDOW_GRAPHICSCREEN         1520
#define MEMORY_GET_WINDOW_GRAPHICSCREEN         1521
#define MEMORY_CLOSE_WINDOW_GRAPHICSCREEN       1522
#define MEMORY_FREE_WINDOW_GRAPHICSCREEN        1523

#define MEMORY_SET_WINDOW_ATTACH                1530
#define MEMORY_GET_WINDOW_ATTACH                1531
#define MEMORY_CLOSE_WINDOW_ATTACH              1532
#define MEMORY_FREE_WINDOW_ATTACH               1533

#define MEMORY_SET_WINDOW_BATTERYRAM            1540
#define MEMORY_GET_WINDOW_BATTERYRAM            1541
#define MEMORY_CLOSE_WINDOW_BATTERYRAM          1542
#define MEMORY_FREE_WINDOW_BATTERYRAM           1543

#define MEMORY_SET_WINDOW_INTERNALS             1550
#define MEMORY_GET_WINDOW_INTERNALS             1551
#define MEMORY_CLOSE_WINDOW_INTERNALS           1552
#define MEMORY_FREE_WINDOW_INTERNALS            1553

#define MEMORY_SET_WINDOW_SYMBOL                1560
#define MEMORY_GET_WINDOW_SYMBOL                1561
#define MEMORY_CLOSE_WINDOW_SYMBOL              1562
#define MEMORY_FREE_WINDOW_SYMBOL               1563

#define MEMORY_SET_WINDOW_BREAKPOINT            1570
#define MEMORY_GET_WINDOW_BREAKPOINT            1571
#define MEMORY_CLOSE_WINDOW_BREAKPOINT          1572
#define MEMORY_FREE_WINDOW_BREAKPOINT           1573

#define MEMORY_SET_WINDOW_STATISTIC             1580
#define MEMORY_GET_WINDOW_STATISTIC             1581
#define MEMORY_CLOSE_WINDOW_STATISTIC           1582
#define MEMORY_FREE_WINDOW_STATISTIC            1583

#define MEMORY_SET_WINDOW_PROFILE               1590
#define MEMORY_GET_WINDOW_PROFILE               1591
#define MEMORY_CLOSE_WINDOW_PROFILE             1592
#define MEMORY_FREE_WINDOW_PROFILE              1593

#define MEMORY_SET_WINDOW_SYMBOL_PICKUP         1600
#define MEMORY_GET_WINDOW_SYMBOL_PICKUP         1601
#define MEMORY_CLOSE_WINDOW_SYMBOL_PICKUP       1602
#define MEMORY_FREE_WINDOW_SYMBOL_PICKUP        1603

#define MEMORY_SET_WINDOW_PREFERENCE            1610
#define MEMORY_GET_WINDOW_PREFERENCE            1611
#define MEMORY_CLOSE_WINDOW_PREFERENCE          1612
#define MEMORY_FREE_WINDOW_PREFERENCE           1613

#define MEMORY_SET_WINDOW_PROGRESSBAR           1620
#define MEMORY_GET_WINDOW_PROGRESSBAR           1621
#define MEMORY_CLOSE_WINDOW_PROGRESSBAR         1622
#define MEMORY_FREE_WINDOW_PROGRESSBAR          1623

#define TRACE_SYSTEM_CALL_P8                    1
#define TRACE_SYSTEM_CALL_P16                   2
#define TRACE_SYSTEM_CALL_GSOS                  4
#define TRACE_SYSTEM_CALL_TOOLBOX               8

struct parameter
{
  /* Instance de l'application */
  HINSTANCE hInstance;

  /* Accelerator Table */
  HACCEL hAccelerator;

  /* Sections  accs controles */
  CRITICAL_SECTION cs_notification_threadhandle;
  CRITICAL_SECTION cs_mmu_threadhandle;
  CRITICAL_SECTION cs_cpu_threadhandle;
  CRITICAL_SECTION cs_memoryarea_threadhandle;
  CRITICAL_SECTION cs_ramsound_threadhandle;
  CRITICAL_SECTION cs_textpage40_threadhandle;
  CRITICAL_SECTION cs_textpage80_threadhandle;
  CRITICAL_SECTION cs_graphicgr_threadhandle;
  CRITICAL_SECTION cs_graphichgr_threadhandle;
  CRITICAL_SECTION cs_graphicdhgrmono_threadhandle;
  CRITICAL_SECTION cs_graphicdhgrcolor_threadhandle;
  CRITICAL_SECTION cs_graphicdgr_threadhandle;
  CRITICAL_SECTION cs_graphichgrtext40_threadhandle;
  CRITICAL_SECTION cs_graphichgrtext80_threadhandle;
  CRITICAL_SECTION cs_graphicgrtext40_threadhandle;
  CRITICAL_SECTION cs_graphicgrtext80_threadhandle;
  CRITICAL_SECTION cs_graphicdgrtext80_threadhandle;
  CRITICAL_SECTION cs_graphicdhgrmonotext80_threadhandle;
  CRITICAL_SECTION cs_graphicdhgrcolortext80_threadhandle;
  CRITICAL_SECTION cs_graphicshr_threadhandle;
  CRITICAL_SECTION cs_disassembler_threadhandle;
  CRITICAL_SECTION cs_loadfile_threadhandle;
  CRITICAL_SECTION cs_savememory_threadhandle;
  CRITICAL_SECTION cs_compare_threadhandle;
  CRITICAL_SECTION cs_quickwatch_threadhandle;
  CRITICAL_SECTION cs_modify_threadhandle;
  CRITICAL_SECTION cs_move_threadhandle;
  CRITICAL_SECTION cs_windowclose_threadhandle;
  CRITICAL_SECTION cs_request;
  CRITICAL_SECTION cs_operation;
  CRITICAL_SECTION cs_shared_memory;
  CRITICAL_SECTION cs_callstack;
  CRITICAL_SECTION cs_profile_stack;
  CRITICAL_SECTION cs_output;
  CRITICAL_SECTION cs_progress_bar;
  CRITICAL_SECTION cs_symbol;

  /* DLL pour les Control RichEdit */
  HMODULE rich_edit_dll;

  /* Cyrene PID */
  DWORD cyrene_pid;

  /* KEGS pid */
  DWORD attach_pid;

  /* Fichier GIF contenant les polices de caractres */
  DWORD char_de_gif_size;
  unsigned char char_de_gif[4096];
  struct picture_true *picture_char_de;
  DWORD char_dk_gif_size;
  unsigned char char_dk_gif[4096];
  struct picture_true *picture_char_dk;
  DWORD char_es_gif_size;
  unsigned char char_es_gif[4096];
  struct picture_true *picture_char_es;
  DWORD char_fr_gif_size;
  unsigned char char_fr_gif[4096];
  struct picture_true *picture_char_fr;
  DWORD char_it_gif_size;
  unsigned char char_it_gif[4096];
  struct picture_true *picture_char_it;
  DWORD char_se_gif_size;
  unsigned char char_se_gif[4096];
  struct picture_true *picture_char_se;
  DWORD char_uk_gif_size;
  unsigned char char_uk_gif[4096];
  struct picture_true *picture_char_uk;
  DWORD char_us_gif_size;
  unsigned char char_us_gif[4096];
  struct picture_true *picture_char_us;
  DWORD char_mousetext_gif_size;
  unsigned char char_mousetext_gif[4096];
  struct picture_true *picture_char_mousetext;
  
  /* Les classes de Fentre ne s'enregistrent qu'une seule fois */
  int register_class_main;
  int register_class_ipc;

  /** Thread Request **/
  int request_thread_status;
  HANDLE request_thread_handle;
  int stop_request_thread;
  int request_unid;
  HANDLE thread_request_event;

  /** Thread IPC **/
  int ipc_thread_status;   
  HANDLE ipc_thread_handle;

  /** Thread Output **/
  int output_thread_status;
  HANDLE output_thread_handle;
  int stop_output_thread;

  /** Handle de la fentre IPC de Kegs **/
  char kegs_ipc_window_name[256];
  HWND hwnd_kegs_ipc;

  /* Status de la connection avec Kegs */
  int kegs_connection_status;

  /* Is it the first operation ? */
  int is_first_operation;

  /** Prochaine opration  excuter **/
  BYTE operation_opcode;                  /* Opcode */
  BYTE operation_operand1;                /* Operand */
  BYTE operation_operand2;
  BYTE operation_operand3;
  WORD operation_PC;                      /* Program Counter */
  BYTE operation_PB;                      /* Program Bank */
  BYTE operation_DB;                      /* Data Bank */
  WORD operation_STACK;                   /* Stack */
  WORD operation_X;                       /* X Register */
  int operation_data_size;                /* Operand Size */
  int operation_nb_cycle;                 /* Nb cycle */
  int operation_status_m;                 /* Accumulator Size */
  int operation_status_x;                 /* X Y Registers Size */
  QWORD operation_goid;                   /* Global Operation ID */
  QWORD operation_gcc;                    /* Global Cycle Count */
  BYTE operation_C02E;                    /* Softswitch VertCnt */
  BYTE operation_C02F;                    /* Softswitch HorizCnt */
  BYTE operation_C035;                    /* Softswitch Shadowing */
  BYTE operation_C068;                    /* Softswitch StateReg */
  DWORD operation_read_address;           /* Read Address */
  DWORD operation_write_address;          /* Write Address */
  DWORD operation_jump_address;           /* Write Address */
  WORD operation_read_value;              /* Read Value */
  WORD operation_write_value;             /* Write Value */
  BYTE operation_flags;                   /* Flags (Interrupt / Size / Wrap) */
  WORD operation_call_number;             /* Call Number */
  DWORD operation_next_op_addr;           /* Next operation address */
  DWORD operation_sub_next_op_addr;       /* Current Function next operation address */

  /** Dernire opration excute **/
  BYTE prev_operation_opcode;             /* Opcode */
  BYTE prev_operation_operand1;           /* Operand */
  BYTE prev_operation_operand2;
  BYTE prev_operation_operand3;
  WORD prev_operation_PC;                 /* Program Counter */
  BYTE prev_operation_PB;                 /* Program Bank */
  BYTE prev_operation_DB;                 /* Data Bank */
  WORD prev_operation_STACK;              /* Stack */
  WORD prev_operation_X;                  /* X Register */
  int prev_operation_data_size;           /* Operand Size */
  int prev_operation_nb_cycle;            /* Nb cycle */
  int prev_operation_status_m;            /* Accumulator Size */
  int prev_operation_status_x;            /* X Y Registers Size */
  QWORD prev_operation_goid;              /* Global Operation ID */
  QWORD prev_operation_gcc;               /* Global Cycle Count */
  BYTE prev_operation_C02E;               /* Softswitch VertCnt */
  BYTE prev_operation_C02F;               /* Softswitch HorizCnt */
  BYTE prev_operation_C035;               /* Softswitch Shadowing */
  BYTE prev_operation_C068;               /* Softswitch StateReg */
  DWORD prev_operation_read_address;      /* Read Address */
  DWORD prev_operation_write_address;     /* Write Address */
  DWORD prev_operation_jump_address;      /* Write Address */
  WORD prev_operation_read_value;         /* Read Value */
  WORD prev_operation_write_value;        /* Write Value */
  BYTE prev_operation_flags;              /* Flags (Interrupt / Size / Wrap) */
  WORD prev_operation_call_number;        /* Call Number */
  DWORD prev_operation_next_op_addr;      /* Next operation address */
  DWORD prev_operation_sub_next_op_addr;  /* Current Function next operation address */

  /** On conserve les information du Pickup Symbol **/
  int symbol_is_available;
  DWORD symbol_address;
  int symbol_size;
  char symbol_name[1024];
  char symbol_segment[1024];
  char symbol_file[1024];

  /* Stat Consolides des Oprations */
  int operation_total_cycle;
  int operation_id;

  /** Fichier de Trace **/
  char trace_file_name[1024];
  int insert_log_break;

  /** Buffer Log **/
  int buffer_ipc_offset;
  char buffer_ipc_log[64*1024];
  int buffer_request_offset;
  char buffer_request_log[64*1024];

  /** Preferences **/
  int trace_p8_calls;
  int trace_p16_calls;
  int trace_gsos_calls;
  int trace_toolbox_calls;

  int nb_ignore_os_call;
  WORD tab_ignore_os_call[1600];
  int nb_traceonly_os_call;
  WORD tab_traceonly_os_call[1600];
  int nb_ignore_toolbox_call;
  WORD tab_ignore_toolbox_call[1600];
  int nb_traceonly_toolbox_call;
  WORD tab_traceonly_toolbox_call[1600];

  int trace_toolbox_001;
  int trace_toolbox_002;
  int trace_toolbox_003;
  int trace_toolbox_004;
  int trace_toolbox_005;
  int trace_toolbox_006;
  int trace_toolbox_007;
  int trace_toolbox_008;
  int trace_toolbox_009;
  int trace_toolbox_010;
  int trace_toolbox_011;
  int trace_toolbox_012;
  int trace_toolbox_013;
  int trace_toolbox_014;
  int trace_toolbox_015;
  int trace_toolbox_016;
  int trace_toolbox_017;
  int trace_toolbox_018;
  int trace_toolbox_019;
  int trace_toolbox_020;
  int trace_toolbox_021;
  int trace_toolbox_022;
  int trace_toolbox_023;
  int trace_toolbox_024;
  int trace_toolbox_025;
  int trace_toolbox_026;
  int trace_toolbox_027;
  int trace_toolbox_028;
  int trace_toolbox_029;
  int trace_toolbox_030;
                          /* 31 is Missing */
  int trace_toolbox_032;
  int trace_toolbox_033;
  int trace_toolbox_034;
  int trace_toolbox_035;
                          /* 36 is Missing */
  int trace_toolbox_037;
  int trace_toolbox_038;
  int trace_toolbox_050;
  int trace_toolbox_051;
  int trace_toolbox_052;
  int trace_toolbox_053;
  int trace_toolbox_128;
  int trace_toolbox_129;
  int trace_toolbox_130;
  int trace_toolbox_131;
  int trace_toolbox_132;
  int trace_toolbox_219;
  int trace_toolbox_220;
  int trace_toolbox_221;
  int trace_toolbox_222;
  int trace_toolbox_230;
  int trace_toolbox_255;

  int trace_display_goid;
  int trace_display_gcc;
  int trace_display_pc_address;
  int trace_display_call_number;

  /* Tableau des appels systmes */
  int nb_systemcall;
  struct system_call **tab_systemcall;
};

struct file_path
{
  char *path;                /* Chemin de fichier */
  
  int size;                  /* Taille des donnes */
  unsigned char *data;       /* Donnes du fichier */

  struct file_path *next;
};

#define MAX_OPERATION       50000

struct operation_set
{
  int nb_operation;
  struct operation *tab_operation;

  struct operation_set *next;
};

struct operation
{
  /* Operation Data (from Kegs) */
  WORD register_A;           /* Accumulator */
  WORD register_X;           /* X Register */
  WORD register_Y;           /* Y Register */
  WORD register_PC;          /* Program Counter */
  BYTE register_PB;          /* Program Bank */
  BYTE register_DB;          /* Data Bank */
  WORD register_STACK;       /* Stack */
  WORD register_DIRECT;      /* Direct Page */
  WORD register_STATUS;      /* Status Regsiter + MX */
  BYTE m_opcode;             /* Opcode */
  BYTE m_operand1;           /* Operand #1 */
  BYTE m_operand2;           /* Operand #2 */
  BYTE m_operand3;           /* Operand #3 */
  DWORD read_address;        /* Read Address */
  DWORD write_address;       /* Write Address */
  DWORD jump_address;        /* Jump Address */
  WORD read_value;           /* Read Value */
  WORD write_value;          /* Write Value */
  BYTE flags;                /* Flags (Interrupt / Size / Wrap) : IWWRRwr- */
  WORD call_number;          /* Call Number (Toolbox / GS/OS) */
  BYTE h_rom;                /* ROM Version : 01 / 03 */
  BYTE h_ram;                /* # Ram Bank (4-) */
  BYTE s_C02E;               /* Softswitch $C02E VertCnt */
  BYTE s_C02F;               /* Softswitch $C02F HorizCnt */
  BYTE s_C035;               /* Softswitch $C035 Shadowing */
  BYTE s_C068;               /* Softswitch $C068 StateReg */
  QWORD goid;                /* Global Operation ID */
  QWORD gcc;                 /* Global Cycle Count */
  DWORD next_op_addr;        /* Next operation address */
  DWORD sub_next_op_addr;    /* Current Function next operation address */
  int data_size;             /* Nb d'octets de la partie Operand */
  int nb_cycle;              /* Nb de Cycle */

  /* Statistiques */
  DWORD operation_id;        /* Numro de l'opration */
  DWORD total_cycle;         /* Total Cycle */
};

void my_Memory(int,void *,void *);
struct parameter *mem_alloc_parameter(HINSTANCE);
void mem_free_param(struct parameter *);
void mem_free_filepath(struct file_path *);

/************************************************************************/
