/************************************************************************/
/*                                                                      */
/*  Window_BatteryRam.h :  Header de gestion de la fentre BatteryRam.  */
/*                                                                      */
/************************************************************************/
/*  Auteur : Olivier ZARDINI   *  Brutal Deluxe   *   Date : Juin 2023  */
/************************************************************************/

/* Un message destin  la fentre Battery Ram pour demander la maj de l'affichage */
#define HM_BATTERYRAM_REFRESHWINDOW    (WM_USER + 25)
#define IDC_RICHEDIT_BATTERYRAM_DATA   1624

#define BATTERYRAM_REFRESH_AUTOMATIC          0
#define BATTERYRAM_REFRESH_MANUAL             1

#define BATTERYRAM_EDIT_FONT_HEIGHT          14    /* Taille de la Fonte en Pixel */

#define BATTERYRAM_RICHEDIT_FONT_HEIGHT      14    /* Taille de la Fonte en Pixel */
#define BATTERYRAM_RICHEDIT_FONT_HEIGHT_RTF "16"  /* Taille de la Fonte dans le RTF */

struct window_batteryram
{
  HWND hwnd_batteryram;
  HWND hwnd_richedit_data;      /* Control Rich Text Multi Line */
  HFONT hFont;  
  
  /* Mode de rafraichissement de la fentre */
  int refresh_mode;        /* BATTERYSOUND_REFRESH_XXX */

  /* Position / Taille du Control Group Box */
  int group_data_x;
  int group_data_y;
  int group_data_width;
  int group_data_height;

  /* Position / Taille du Control Text Zone RamSound Data */
  int batteryram_data_x;
  int batteryram_data_y;
  int batteryram_data_width;
  int batteryram_data_height;

  /** Control Edit : Zone Texte o sont affiches les Data **/   
  int text_data_column;            /* Nombre de colonne Data */
  int text_data_row;               /* Nombre de ligne Data */
  int text_data_width;             /* "00/0000___00_00_00_00_00_00_00_00.00_00_00_00_00_00_00_00__ASCII\r\n" */
  int rtf_data_size;               /* Taille de la Zone Texte RTF */
  char *rtf_data_hexadecimal;      /* Zone Texte RTF */  
  int rtf_write_offset;            /* Offset de l'criture de la Zone Texte RTF vers le Rich Edit */

  /** Donnes actuellement affiches **/
  int batteryram_address;
  int nb_column;
  int nb_row;
  unsigned char *batteryram_data;

  /* Dimension de la fentre = Title + Zone Texte */
  int title_height;
  int window_width;
  int window_height;
  
  /* Buffer */
  char buffer_log[BUFFER_SIZE];

  /* Notification */
  struct notification *current_notification;

  /* Liste chaine des Battery Ram */
  struct window_batteryram *next;
};

struct window_batteryram *BuildBatteryRamWindow(HINSTANCE,int);
void mem_free_window_batteryram(struct window_batteryram *);

/********************************************************/
