/**************************************************************************/
/*                                                                        */
/*  Window_DOCRegister.h :  Header de gestion de la fentre DOCRegister.  */
/*                                                                        */
/**************************************************************************/
/*  Auteur : Olivier ZARDINI  *  Brutal Deluxe  *  Date : Septembre 2018  */
/**************************************************************************/

/* Un message destin  la fentre DOC Register pour demander la maj de l'affichage */
#define HM_DOCREGISTER_REFRESHWINDOW   (WM_USER + 22)

#define DOCREGISTER_REFRESH_AUTOMATIC  0
#define DOCREGISTER_REFRESH_MANUAL     1

struct window_docregister
{
  HWND hwnd_docregister;
  
  /* Mode de rafraichissement de la fentre */
  int refresh_mode;        /* DOCREGISTER_REFRESH_XXX */

  /** Donne actuellement affiche **/
  unsigned char docregister_data[DOC_REGISTER_SIZE];
  unsigned char docregister_data_old[DOC_REGISTER_SIZE];

  /* Dimension de la fentre = Title + Zone Texte */
  int title_height;
  int window_width;
  int window_height;
  
  /* Buffer */
  char buffer_log[BUFFER_SIZE];
  
  /* Notification */
  struct notification *current_notification;
};

struct window_docregister *BuildDOCRegisterWindow(HINSTANCE,int);
void mem_free_window_docregister(struct window_docregister *);

/************************************************************/
