/************************************************************************/
/*                                                                      */
/*  Window_DirectPage.h :  Header de gestion de la fentre DirectPage.  */
/*                                                                      */
/************************************************************************/
/*  Auteur : Olivier ZARDINI  *   Brutal Deluxe   *   Date : Juin 2018  */
/************************************************************************/

/* Un message destin  la fentre Direct Page pour demander la maj de l'affichage */
#define HM_DIRECTPAGE_REFRESHWINDOW   (WM_USER + 22)
#define IDC_EDIT_DIRECTPAGE_DATA      1623

#define DIRECTPAGE_REFRESH_AUTOMATIC  0
#define DIRECTPAGE_REFRESH_MANUAL     1

#define DIRECTPAGE_EDIT_FONT_HEIGHT   14    /* Taille de la Fonte en Pixel */

struct window_directpage
{
  HWND hwnd_directpage;
  HWND hwnd_edit_data;          /* Control Text Multi Ligne */
  HFONT hFont;  
  
  /* Surchage des Control Edit pour rcuprer les vnements Souris */
  WNDPROC oldEditProcDirectPageData;
  
  /* Mode de rafraichissement de la fentre */
  int refresh_mode;        /* DIRECTPAGE_REFRESH_XXX */

  /* Posiiton / Taille du Control Group Box */
  int group_data_x;
  int group_data_y;
  int group_data_width;
  int group_data_height;

  /* Position / Taille du Control Text Zone DirectPage Data */
  int directpage_data_x;
  int directpage_data_y;
  int directpage_data_width;
  int directpage_data_height;

  /** Control Edit : Zone Texte o sont affiches les Data **/  
  int nb_line;                     /* 16 */  
  int nb_column;                   /* 16 */
  int text_data_width;             /* "00/0000___00_00_00_00_00_00_00_00.00_00_00_00_00_00_00_00\r\n" */
  int text_data_size;              /* text_data_width*column */
  char *text_data_hexadecimal;     /* Zone Texte column*line */ 

  /** Donne actuellement affiche **/
  int directpage_address;
  unsigned char directpage_data[256];

  /* Dimension de la fentre = Title + Zone Texte */
  int title_height;
  int window_width;
  int window_height;
  
  /* Buffer */
  char buffer_log[BUFFER_SIZE];
  
  /* Notification */
  struct notification *current_notification;
};

struct window_directpage *BuildDirectPageWindow(HINSTANCE,int);
void mem_free_window_directpage(struct window_directpage *);

/********************************************************/
