/********************************************************************/
/*                                                                  */
/*  Window_Stack.h :  Header de gestion de la fentre Stack.        */
/*                                                                  */
/********************************************************************/
/*  Auteur : Olivier ZARDINI  *  Brutal Deluxe  *  Date : Mai 2018  */
/********************************************************************/

/* Un message destin  la fentre Stack pour demander la maj de l'affichage */
#define HM_STACK_REFRESHWINDOW             (WM_USER + 21)
#define IDC_EDIT_STACK_DATA                1621
#define IDC_RICHEDIT_STACK_DATA            1622

#define STACK_REFRESH_AUTOMATIC     0
#define STACK_REFRESH_MANUAL        1

/* Pixmap sous le Stack Pointer */
#define STACK_SELECT_WIDTH         16
#define STACK_SELECT_HEIGHT         1

#define STACK_POINTER_COLOR       MAKECOLOR(255,33,221)

struct window_stack
{
  HWND hwnd_stack;
  HWND hwnd_edit;          /* Control Text Multi Ligne */
  HWND hwnd_richedit;
  HFONT hFont;

  /** Graphical element attributes **/
  HDC hDC;
  HDC hCompatibleDC;
  HBITMAP hBitmap_stack_pointer;      /* Trait pour le Stack Pointer */
  DWORD *bitmap_stack_pointer;
  
  /* Mode de reafraichissement de la fentre */
  int refresh_mode;        /* STACK_REFRESH_XXX */

  /* Position de la Zone Stack Data Text */
  int stack_data_x;
  int stack_data_y;

  /* Dimension de la zone Data en byte */
  int column;                      /* 16 */
  int line;                        /* 16 */

  /** Control Edit : Zone Texte o sont affiches les Data **/
  int text_data_width;             /* "00/0000___00_00_00_00_00_00_00_00.00_00_00_00_00_00_00_00\r\n" */
  int text_data_size;              /* text_data_width*column */
  char *text_data_hexadecimal;     /* Zone Texte column*line */  

  /** Donne actuellement affiche **/
  int stack_address;
  int stack_data_base_address;
  unsigned char stack_data[256];

  /* Dimension en pixel de la Zone Texte */
  int text_area_width;
  int text_area_height;

  /* Dimension de la fentre = Title + Zone Texte */
  int title_height;
  int window_width;
  int window_height;
  
  /* Buffer */
  char buffer_log[BUFFER_SIZE];
  
  /* Notification */
  struct notification *current_notification;
};

struct window_stack *BuildStackWindow(HINSTANCE,int);
int BuildHexadecimalGraphicText(struct window_stack *,int);
void BuildHexadecimalGraphicViewFromData(void);
void mem_free_window_stack(struct window_stack *);

/********************************************************/
