/************************************************************************/
/*                                                                      */
/*  Window_GraphicDGR.h :  Header de gestion de la fentre GraphicDGR.  */
/*                                                                      */
/************************************************************************/
/*  Auteur : Olivier ZARDINI  *  Brutal Deluxe  *  Date : Juillet 2018  */
/************************************************************************/

/* Un message destin  la fentre Graphic DGR pour demander la maj de l'affichage */
#define HM_GRAPHICDGR_REFRESHWINDOW               (WM_USER + 27)

#define GRAPHICDGR_REFRESH_AUTOMATIC  0
#define GRAPHICDGR_REFRESH_MANUAL     1

#define GRAPHICDGR_ZOOM_X1            1
#define GRAPHICDGR_ZOOM_X2            2

#define GRAPHICDGR_EDIT_FONT_HEIGHT   14    /* Taille de la Fonte en Pixel */

#define GRAPHICDGR_DIALOGBOX_WIDTH    417   /* Largeur minimale en Pixel de la fentre */

struct window_graphicdgr
{
  HWND hwnd_graphicdgr;

  DWORD thread_id;                   /* Le ThreadID va permettre de diffrencier les diffrentes fentres */

  /** Graphical element attributes **/
  HDC hDC;
  HDC hCompatibleDC;
  HBITMAP hBitmap_graphicdgr;        /* Bitmap affichant la zone de slecion */
  DWORD *bitmap_data_graphicdgr;

  /* Surchage des Control Edit pour rcuprer les vnements Souris + Entre */
  WNDPROC oldEditProcBank;
  WNDPROC oldEditProcAddress;
  
  /* Mode de rafraichissement de la fentre */
  int refresh_mode;        /* GRAPHICDGR_REFRESH_XXX */
    
  /* Zoom Level */
  int zoom_level;

  /* Posiiton / Taille du Control Group Box */
  int group_data_x;
  int group_data_y;
  int group_data_width;
  int group_data_height;

  /* Position / Taille de la Bitmap DGR Data */
  int bitmap_graphicdgr_x;
  int bitmap_graphicdgr_y;
  int bitmap_graphicdgr_width;   /* 280 */
  int bitmap_graphicdgr_height;  /* 192 */

  /** Donnes actuellement affiches **/
  int graphicdgr_bank;
  int graphicdgr_address;
  unsigned char graphicdgr_data[80*24];

  /* Dimension de la fentre = Title + Zone Texte */
  int title_height;
  int window_width;
  int window_height;

  /* Buffer */
  char buffer_log[BUFFER_SIZE];

  /* Notification */
  struct notification *current_notification;

  /* Liste chaine des Graphic DGR */
  struct window_graphicdgr *next;
};

struct window_graphicdgr *BuildGraphicDGRWindow(HINSTANCE,int);
void mem_free_window_graphicdgr(struct window_graphicdgr *);

/***************************************************************/
