/************************************************************************************/
/*                                                                                  */
/*  Window_GraphicDGRText80.h :  Header de gestion de la fentre GraphicDGRText80.  */
/*                                                                                  */
/************************************************************************************/
/*   Auteur : Olivier ZARDINI     *     Brutal Deluxe     *     Date : Aout 2018    */
/************************************************************************************/

/* Un message destin  la fentre Graphic DGR Text 80 pour demander la maj de l'affichage */
#define HM_GRAPHICDGRTEXT80_REFRESHWINDOW               (WM_USER + 32)
#define IDC_COMBOBOX_GRAPHICDGRTEXT80_COLOR_TEXT        1628
#define IDC_COMBOBOX_GRAPHICDGRTEXT80_COLOR_BACKGROUND  1629
#define IDC_COMBOBOX_GRAPHICDGRTEXT80_DISPLAY_LANGUAGE  1630

#define GRAPHICDGRTEXT80_REFRESH_AUTOMATIC  0
#define GRAPHICDGRTEXT80_REFRESH_MANUAL     1

#define GRAPHICDGRTEXT80_ZOOM_X1            1
#define GRAPHICDGRTEXT80_ZOOM_X2            2

#define GRAPHICDGRTEXT80_EDIT_FONT_HEIGHT   14    /* Taille de la Fonte en Pixel */

#define GRAPHICDGRTEXT80_DIALOGBOX_WIDTH    424   /* Largeur minimale en Pixel de la fentre */

struct window_graphicdgrtext80
{
  HWND hwnd_graphicdgrtext80;
  HWND hwnd_combo_color_text;         /* ComboBox pour le Color Text */
  HWND hwnd_combo_color_background;   /* ComboBox pour le Color Background */
  HWND hwnd_combo_display_language;   /* ComboBox pour le Display Language */
  HFONT hFont;

  DWORD thread_id;              /* Le ThreadID va permettre de diffrencier les diffrentes fentres */

  /** Graphical element attributes **/
  HDC hDC;
  HDC hCompatibleDC;
  HBITMAP hBitmap_graphicdgrtext80;    /* Bitmap affchant la zone de slecion */
  DWORD *bitmap_data_graphicdgrtext80;

  /* Surchage des Control Edit pour rcuprer les vnements Souris + Entre */
  WNDPROC oldEditProcBankGraphic;
  WNDPROC oldEditProcAddressGraphic;
  WNDPROC oldEditProcBankText;
  WNDPROC oldEditProcAddressText;
  
  /* Mode de rafraichissement de la fentre */
  int refresh_mode;        /* GRAPHICDGRTEXT80_REFRESH_XXX */

  /* Couleur */
  int color_text;
  int color_background;
  
  /* Language */
  int display_language;

  /* Zoom Level */
  int zoom_level;

  /* Posiiton / Taille du Control Group Box */
  int group_data_x;
  int group_data_y;
  int group_data_width;
  int group_data_height;

  /* Position / Taille de la Bitmap GraphicDGRText80 Data */
  int bitmap_graphicdgrtext80_x;
  int bitmap_graphicdgrtext80_y;
  int bitmap_graphicdgrtext80_width;   /* 560 */
  int bitmap_graphicdgrtext80_height;  /* 192 */

  /** Donnes actuellement affiches **/
  /* Graphic */
  int graphicdgr_bank;
  int graphicdgr_address;
  unsigned char graphicdgr_data[80*24];
  /* Text */
  int textpage80_bank;
  int textpage80_address;
  unsigned char textpage80_data[80*24];

  /* Dimension de la fentre = Title + Zone Texte */
  int title_height;
  int window_width;
  int window_height;

  /* Buffer */
  char buffer_log[BUFFER_SIZE];

  /* Notification */
  struct notification *current_notification;

  /* Liste chaine des GraphicDGRText80 */
  struct window_graphicdgrtext80 *next;
};

struct window_graphicdgrtext80 *BuildGraphicDGRText80Window(HINSTANCE,int);
void mem_free_window_graphicdgrtext80(struct window_graphicdgrtext80 *);

/********************************************************/
