/************************************************************************************/
/*                                                                                  */
/*  Window_GraphicDHGRColor.h :  Header de gestion de la fentre GraphicDHGRColor.  */
/*                                                                                  */
/************************************************************************************/
/*    Auteur : Olivier ZARDINI    *    Brutal Deluxe    *    Date : Juillet 2018    */
/************************************************************************************/

/* Un message destin  la fentre Graphic DHGR Color pour demander la maj de l'affichage */
#define HM_GRAPHICDHGRCOLOR_REFRESHWINDOW               (WM_USER + 26)

#define GRAPHICDHGRCOLOR_REFRESH_AUTOMATIC  0
#define GRAPHICDHGRCOLOR_REFRESH_MANUAL     1

#define GRAPHICDHGRCOLOR_ZOOM_X1            1
#define GRAPHICDHGRCOLOR_ZOOM_X2            2
#define GRAPHICDHGRCOLOR_ZOOM_X3            3

#define GRAPHICDHGRCOLOR_EDIT_FONT_HEIGHT   14    /* Taille de la Fonte en Pixel */

#define GRAPHICDHGRCOLOR_DIALOGBOX_WIDTH    417   /* Largeur minimale en Pixel de la fentre */

struct window_graphicdhgrcolor
{
  HWND hwnd_graphicdhgrcolor;

  DWORD thread_id;              /* Le ThreadID va permettre de diffrencier les diffrentes fentres */

  /** Graphical element attributes **/
  HDC hDC;
  HDC hCompatibleDC;
  HBITMAP hBitmap_graphicdhgrcolor;    /* Bitmap affchant la zone de slecion */
  DWORD *bitmap_data_graphicdhgrcolor;

  /* Surchage des Control Edit pour rcuprer les vnements Souris + Entre */
  WNDPROC oldEditProcBank;
  WNDPROC oldEditProcAddress;
  
  /* Mode de rafraichissement de la fentre */
  int refresh_mode;        /* GRAPHICDHGRCOLOR_REFRESH_XXX */
    
  /* Zoom Level */
  int zoom_level;

  /* Posiiton / Taille du Control Group Box */
  int group_data_x;
  int group_data_y;
  int group_data_width;
  int group_data_height;

  /* Position / Taille de la Bitmap DHGR Color Data */
  int bitmap_graphicdhgrcolor_x;
  int bitmap_graphicdhgrcolor_y;
  int bitmap_graphicdhgrcolor_width;   /* 280 */
  int bitmap_graphicdhgrcolor_height;  /* 192 */

  /** Donnes actuellement affiches **/
  int graphicdhgrcolor_bank;
  int graphicdhgrcolor_address;
  unsigned char graphicdhgrcolor_data[80*192];

  /* Dimension de la fentre = Title + Zone Texte */
  int title_height;
  int window_width;
  int window_height;

  /* Buffer */
  char buffer_log[BUFFER_SIZE];

  /* Notification */
  struct notification *current_notification;

  /* Liste chaine des Graphic DHGR Color */
  struct window_graphicdhgrcolor *next;
};

struct window_graphicdhgrcolor *BuildGraphicDHGRColorWindow(HINSTANCE,int);
void mem_free_window_graphicdhgrcolor(struct window_graphicdhgrcolor *);

/***************************************************************/
