/**********************************************************************************/
/*                                                                                */
/*  Window_GraphicDHGRMono.h :  Header de gestion de la fentre GraphicDHGRMono.  */
/*                                                                                */
/**********************************************************************************/
/*  Auteur : Olivier ZARDINI    *    Brutal Deluxe    *    Date : Juillet 2018    */
/**********************************************************************************/

/* Un message destin  la fentre Graphic DHGR Mono pour demander la maj de l'affichage */
#define HM_GRAPHICDHGRMONO_REFRESHWINDOW               (WM_USER + 25)

#define GRAPHICDHGRMONO_REFRESH_AUTOMATIC  0
#define GRAPHICDHGRMONO_REFRESH_MANUAL     1

#define GRAPHICDHGRMONO_ZOOM_X1            1
#define GRAPHICDHGRMONO_ZOOM_X2            2

#define GRAPHICDHGRMONO_EDIT_FONT_HEIGHT   14    /* Taille de la Fonte en Pixel */

#define GRAPHICDHGRMONO_DIALOGBOX_WIDTH    417   /* Largeur minimale en Pixel de la fentre */

struct window_graphicdhgrmono
{
  HWND hwnd_graphicdhgrmono;

  DWORD thread_id;              /* Le ThreadID va permettre de diffrencier les diffrentes fentres */

  /** Graphical element attributes **/
  HDC hDC;
  HDC hCompatibleDC;
  HBITMAP hBitmap_graphicdhgrmono;    /* Bitmap affchant la zone de slecion */
  DWORD *bitmap_data_graphicdhgrmono;

  /* Surchage des Control Edit pour rcuprer les vnements Souris + Entre */
  WNDPROC oldEditProcBank;
  WNDPROC oldEditProcAddress;
  
  /* Mode de rafraichissement de la fentre */
  int refresh_mode;        /* GRAPHICDHGRMONO_REFRESH_XXX */
    
  /* Zoom Level */
  int zoom_level;

  /* Posiiton / Taille du Control Group Box */
  int group_data_x;
  int group_data_y;
  int group_data_width;
  int group_data_height;

  /* Position / Taille de la Bitmap DHGR Mono Data */
  int bitmap_graphicdhgrmono_x;
  int bitmap_graphicdhgrmono_y;
  int bitmap_graphicdhgrmono_width;   /* 560 */
  int bitmap_graphicdhgrmono_height;  /* 192 */

  /** Donnes actuellement affiches **/
  int graphicdhgrmono_bank;
  int graphicdhgrmono_address;
  unsigned char graphicdhgrmono_data[80*192];

  /* Dimension de la fentre = Title + Zone Texte */
  int title_height;
  int window_width;
  int window_height;

  /* Buffer */
  char buffer_log[BUFFER_SIZE];

  /* Notification */
  struct notification *current_notification;

  /* Liste chaine des Graphic DHGR Mono */
  struct window_graphicdhgrmono *next;
};

struct window_graphicdhgrmono *BuildGraphicDHGRMonoWindow(HINSTANCE,int);
void mem_free_window_graphicdhgrmono(struct window_graphicdhgrmono *);

/***************************************************************/
