/********************************************************************************************/
/*                                                                                          */
/* Window_GraphicDHGRMonoText80.h :  Header de gestion de la fentre GraphicDHGRMonoText80. */
/*                                                                                          */
/********************************************************************************************/
/*    Auteur : Olivier ZARDINI       *      Brutal Deluxe      *       Date : Aout 2018     */
/********************************************************************************************/

/* Un message destin  la fentre Graphic DHGR Mono Text 80 pour demander la maj de l'affichage */
#define HM_GRAPHICDHGRMONOTEXT80_REFRESHWINDOW               (WM_USER + 33)
#define IDC_COMBOBOX_GRAPHICDHGRMONOTEXT80_COLOR_TEXT        1628
#define IDC_COMBOBOX_GRAPHICDHGRMONOTEXT80_COLOR_BACKGROUND  1629
#define IDC_COMBOBOX_GRAPHICDHGRMONOTEXT80_DISPLAY_LANGUAGE  1630

#define GRAPHICDHGRMONOTEXT80_REFRESH_AUTOMATIC    0
#define GRAPHICDHGRMONOTEXT80_REFRESH_MANUAL       1

#define GRAPHICDHGRMONOTEXT80_ZOOM_X1              1
#define GRAPHICDHGRMONOTEXT80_ZOOM_X2              2

#define GRAPHICDHGRMONOTEXT80_EDIT_FONT_HEIGHT    14   /* Taille de la Fonte en Pixel */

#define GRAPHICDHGRMONOTEXT80_DIALOGBOX_WIDTH    426   /* Largeur minimale en Pixel de la fentre */

struct window_graphicdhgrmonotext80
{
  HWND hwnd_graphicdhgrmonotext80;
  HWND hwnd_combo_color_text;         /* ComboBox pour le Color Text */
  HWND hwnd_combo_color_background;   /* ComboBox pour le Color Background */
  HWND hwnd_combo_display_language;   /* ComboBox pour le Display Language */
  HFONT hFont;

  DWORD thread_id;              /* Le ThreadID va permettre de diffrencier les diffrentes fentres */

  /** Graphical element attributes **/
  HDC hDC;
  HDC hCompatibleDC;
  HBITMAP hBitmap_graphicdhgrmonotext80;    /* Bitmap affchant la zone de slecion */
  DWORD *bitmap_data_graphicdhgrmonotext80;

  /* Surchage des Control Edit pour rcuprer les vnements Souris + Entre */
  WNDPROC oldEditProcBankGraphic;
  WNDPROC oldEditProcAddressGraphic;
  WNDPROC oldEditProcBankText;
  WNDPROC oldEditProcAddressText;

  /* Mode de rafraichissement de la fentre */
  int refresh_mode;        /* GRAPHICDHGRMONOTEXT80_REFRESH_XXX */

  /* Couleur */
  int color_text;
  int color_background;
  
  /* Language */
  int display_language;

  /* Zoom Level */
  int zoom_level;

  /* Posiiton / Taille du Control Group Box */
  int group_data_x;
  int group_data_y;
  int group_data_width;
  int group_data_height;

  /* Position / Taille de la Bitmap GraphicDHGRMonoText80 Data */
  int bitmap_graphicdhgrmonotext80_x;
  int bitmap_graphicdhgrmonotext80_y;
  int bitmap_graphicdhgrmonotext80_width;   /* 560 */
  int bitmap_graphicdhgrmonotext80_height;  /* 192 */

  /** Donnes actuellement affiches **/
  /* Graphic */
  int graphicdhgr_bank;
  int graphicdhgr_address;
  unsigned char graphicdhgr_data[80*192];
  /* Text */
  int textpage80_bank;
  int textpage80_address;
  unsigned char textpage80_data[80*24];

  /* Dimension de la fentre = Title + Zone Texte */
  int title_height;
  int window_width;
  int window_height;

  /* Buffer */
  char buffer_log[BUFFER_SIZE];

  /* Notification */
  struct notification *current_notification;

  /* Liste chaine des GraphicDHGRMonoText80 */
  struct window_graphicdhgrmonotext80 *next;
};

struct window_graphicdhgrmonotext80 *BuildGraphicDHGRMonoText80Window(HINSTANCE,int);
void mem_free_window_graphicdhgrmonotext80(struct window_graphicdhgrmonotext80 *);

/********************************************************/
