/************************************************************************/
/*                                                                      */
/*  Window_GraphicGR.h :  Header de gestion de la fentre GraphicGR.    */
/*                                                                      */
/************************************************************************/
/*  Auteur : Olivier ZARDINI  *  Brutal Deluxe  *  Date : Juillet 2018  */
/************************************************************************/

/* Un message destin  la fentre Graphic GR pour demander la maj de l'affichage */
#define HM_GRAPHICGR_REFRESHWINDOW               (WM_USER + 24)

#define GRAPHICGR_REFRESH_AUTOMATIC  0
#define GRAPHICGR_REFRESH_MANUAL     1

#define GRAPHICGR_ZOOM_X1            1
#define GRAPHICGR_ZOOM_X2            2
#define GRAPHICGR_ZOOM_X3            3

#define GRAPHICGR_EDIT_FONT_HEIGHT   14    /* Taille de la Fonte en Pixel */

#define GRAPHICGR_DIALOGBOX_WIDTH    417   /* Largeur minimale en Pixel de la fentre */

struct window_graphicgr
{
  HWND hwnd_graphicgr;

  DWORD thread_id;              /* Le ThreadID va permettre de diffrencier les diffrentes fentres */

  /** Graphical element attributes **/
  HDC hDC;
  HDC hCompatibleDC;
  HBITMAP hBitmap_graphicgr;    /* Bitmap affchant la zone de slecion */
  DWORD *bitmap_data_graphicgr;

  /* Surchage des Control Edit pour rcuprer les vnements Souris */
  WNDPROC oldEditProcGraphicGRData;
  
  /* Mode de rafraichissement de la fentre */
  int refresh_mode;        /* GRAPHICGR_REFRESH_XXX */
    
  /* Zoom Level */
  int zoom_level;

  /* Posiiton / Taille du Control Group Box */
  int group_data_x;
  int group_data_y;
  int group_data_width;
  int group_data_height;

  /* Position / Taille de la Bitmap GR Data */
  int bitmap_graphicgr_x;
  int bitmap_graphicgr_y;
  int bitmap_graphicgr_width;   /* 280 */
  int bitmap_graphicgr_height;  /* 192 */

  /** Donnes actuellement affiches **/
  int graphicgr_bank;
  int graphicgr_address;
  unsigned char graphicgr_data[40*24];

  /* Dimension de la fentre = Title + Zone Texte */
  int title_height;
  int window_width;
  int window_height;

  /* Buffer */
  char buffer_log[BUFFER_SIZE];

  /* Notification */
  struct notification *current_notification;

  /* Liste chaine des Graphic GR */
  struct window_graphicgr *next;
};

struct window_graphicgr *BuildGraphicGRWindow(HINSTANCE,int);
void mem_free_window_graphicgr(struct window_graphicgr *);

/***************************************************************/
