/**********************************************************************************/
/*                                                                                */
/*  Window_GraphicGRText40.h :  Header de gestion de la fentre GraphicGRText40.  */
/*                                                                                */
/**********************************************************************************/
/*    Auteur : Olivier ZARDINI     *    Brutal Deluxe    *   Date : Juillet 2018  */
/**********************************************************************************/

/* Un message destin  la fentre GraphicGRText40 pour demander la maj de l'affichage */
#define HM_GRAPHICGRTEXT40_REFRESHWINDOW               (WM_USER + 29)
#define IDC_COMBOBOX_GRAPHICGRTEXT40_COLOR_TEXT        1625
#define IDC_COMBOBOX_GRAPHICGRTEXT40_COLOR_BACKGROUND  1626
#define IDC_COMBOBOX_GRAPHICGRTEXT40_DISPLAY_LANGUAGE  1627

#define GRAPHICGRTEXT40_REFRESH_AUTOMATIC  0
#define GRAPHICGRTEXT40_REFRESH_MANUAL     1

#define GRAPHICGRTEXT40_ZOOM_X1            1
#define GRAPHICGRTEXT40_ZOOM_X2            2
#define GRAPHICGRTEXT40_ZOOM_X3            3

#define GRAPHICGRTEXT40_EDIT_FONT_HEIGHT   14    /* Taille de la Fonte en Pixel */

#define GRAPHICGRTEXT40_DIALOGBOX_WIDTH    424   /* Largeur minimale en Pixel de la fentre */

struct window_graphicgrtext40
{
  HWND hwnd_graphicgrtext40;
  HWND hwnd_combo_color_text;         /* ComboBox pour le Color Text */
  HWND hwnd_combo_color_background;   /* ComboBox pour le Color Background */
  HWND hwnd_combo_display_language;   /* ComboBox pour le Display Language */
  HFONT hFont;

  DWORD thread_id;              /* Le ThreadID va permettre de diffrencier les diffrentes fentres */

  /** Graphical element attributes **/
  HDC hDC;
  HDC hCompatibleDC;
  HBITMAP hBitmap_graphicgrtext40;    /* Bitmap affchant la zone de slecion */
  DWORD *bitmap_data_graphicgrtext40;

  /* Surchage des Control Edit pour rcuprer les vnements Souris + Entre */
  WNDPROC oldEditProcBankGraphic;
  WNDPROC oldEditProcAddressGraphic;
  WNDPROC oldEditProcBankText;
  WNDPROC oldEditProcAddressText;

  /* Mode de rafraichissement de la fentre */
  int refresh_mode;        /* GRAPHICGRTEXT40_REFRESH_XXX */

  /* Couleur */
  int color_text;
  int color_background;
  
  /* Flash Character */
  int flash;
  
  /* Language */
  int display_language;

  /* Zoom Level */
  int zoom_level;

  /* Posiiton / Taille du Control Group Box */
  int group_data_x;
  int group_data_y;
  int group_data_width;
  int group_data_height;

  /* Position / Taille de la Bitmap TextPage40 Data */
  int bitmap_graphicgrtext40_x;
  int bitmap_graphicgrtext40_y;
  int bitmap_graphicgrtext40_width;   /* 280 */
  int bitmap_graphicgrtext40_height;  /* 192 */

  /** Donnes actuellement affiches **/
  /* Zone Graphique */
  int graphicgr_bank;
  int graphicgr_address;
  unsigned char graphicgr_data[40*24];
  /* Zone Texte */
  int textpage40_bank;
  int textpage40_address;
  unsigned char textpage40_data[40*24];
  int has_flash_character;

  /* Dimension de la fentre = Title + Zone Texte */
  int title_height;
  int window_width;
  int window_height;

  /* Buffer */
  char buffer_log[BUFFER_SIZE];

  /* Notification */
  struct notification *current_notification;

  /* Liste chaine des GraphicGRText40 */
  struct window_graphicgrtext40 *next;
};

struct window_graphicgrtext40 *BuildGraphicGRText40Window(HINSTANCE,int);
void mem_free_window_graphicgrtext40(struct window_graphicgrtext40 *);

/********************************************************/
