/**********************************************************************************/
/*                                                                                */
/*  Window_GraphicGRText80.h :  Header de gestion de la fentre GraphicGRText80.  */
/*                                                                                */
/**********************************************************************************/
/*   Auteur : Olivier ZARDINI    *    Brutal Deluxe    *    Date : Juillet 2018   */
/**********************************************************************************/

/* Un message destin  la fentre Graphic GR Text 80 pour demander la maj de l'affichage */
#define HM_GRAPHICGRTEXT80_REFRESHWINDOW               (WM_USER + 31)
#define IDC_COMBOBOX_GRAPHICGRTEXT80_COLOR_TEXT        1628
#define IDC_COMBOBOX_GRAPHICGRTEXT80_COLOR_BACKGROUND  1629
#define IDC_COMBOBOX_GRAPHICGRTEXT80_DISPLAY_LANGUAGE  1630

#define GRAPHICGRTEXT80_REFRESH_AUTOMATIC  0
#define GRAPHICGRTEXT80_REFRESH_MANUAL     1

#define GRAPHICGRTEXT80_ZOOM_X1            1
#define GRAPHICGRTEXT80_ZOOM_X2            2

#define GRAPHICGRTEXT80_EDIT_FONT_HEIGHT   14    /* Taille de la Fonte en Pixel */

#define GRAPHICGRTEXT80_DIALOGBOX_WIDTH    424   /* Largeur minimale en Pixel de la fentre */

struct window_graphicgrtext80
{
  HWND hwnd_graphicgrtext80;
  HWND hwnd_combo_color_text;         /* ComboBox pour le Color Text */
  HWND hwnd_combo_color_background;   /* ComboBox pour le Color Background */
  HWND hwnd_combo_display_language;   /* ComboBox pour le Display Language */
  HFONT hFont;

  DWORD thread_id;              /* Le ThreadID va permettre de diffrencier les diffrentes fentres */

  /** Graphical element attributes **/
  HDC hDC;
  HDC hCompatibleDC;
  HBITMAP hBitmap_graphicgrtext80;    /* Bitmap affchant la zone de slecion */
  DWORD *bitmap_data_graphicgrtext80;

  /* Surchage des Control Edit pour rcuprer les vnements Souris + Entre */
  WNDPROC oldEditProcBankGraphic;
  WNDPROC oldEditProcAddressGraphic;
  WNDPROC oldEditProcBankText;
  WNDPROC oldEditProcAddressText;

  /* Mode de rafraichissement de la fentre */
  int refresh_mode;        /* GRAPHICGRTEXT80_REFRESH_XXX */

  /* Couleur */
  int color_text;
  int color_background;
  
  /* Language */
  int display_language;

  /* Zoom Level */
  int zoom_level;

  /* Posiiton / Taille du Control Group Box */
  int group_data_x;
  int group_data_y;
  int group_data_width;
  int group_data_height;

  /* Position / Taille de la Bitmap GraphicGRText80 Data */
  int bitmap_graphicgrtext80_x;
  int bitmap_graphicgrtext80_y;
  int bitmap_graphicgrtext80_width;   /* 560 */
  int bitmap_graphicgrtext80_height;  /* 192 */

  /** Donnes actuellement affiches **/
  /* Graphic */
  int graphicgr_bank;
  int graphicgr_address;
  unsigned char graphicgr_data[40*24];
  /* Text */
  int textpage80_bank;
  int textpage80_address;
  unsigned char textpage80_data[80*24];

  /* Dimension de la fentre = Title + Zone Texte */
  int title_height;
  int window_width;
  int window_height;

  /* Buffer */
  char buffer_log[BUFFER_SIZE];

  /* Notification */
  struct notification *current_notification;

  /* Liste chaine des GraphicGRText80 */
  struct window_graphicgrtext80 *next;
};

struct window_graphicgrtext80 *BuildGraphicGRText80Window(HINSTANCE,int);
void mem_free_window_graphicgrtext80(struct window_graphicgrtext80 *);

/********************************************************/
