/************************************************************************/
/*                                                                      */
/*  Window_GraphicHGR.h :  Header de gestion de la fentre GraphicHGR.  */
/*                                                                      */
/************************************************************************/
/*  Auteur : Olivier ZARDINI  *  Brutal Deluxe  *  Date : Juillet 2018  */
/************************************************************************/

/* Un message destin  la fentre Graphic HGR pour demander la maj de l'affichage */
#define HM_GRAPHICHGR_REFRESHWINDOW               (WM_USER + 24)

#define GRAPHICHGR_REFRESH_AUTOMATIC  0
#define GRAPHICHGR_REFRESH_MANUAL     1

#define GRAPHICHGR_ZOOM_X1            1
#define GRAPHICHGR_ZOOM_X2            2
#define GRAPHICHGR_ZOOM_X3            3

#define GRAPHICHGR_EDIT_FONT_HEIGHT   14    /* Taille de la Fonte en Pixel */

#define GRAPHICHGR_DIALOGBOX_WIDTH    417   /* Largeur minimale en Pixel de la fentre */

struct window_graphichgr
{
  HWND hwnd_graphichgr;

  DWORD thread_id;              /* Le ThreadID va permettre de diffrencier les diffrentes fentres */

  /** Graphical element attributes **/
  HDC hDC;
  HDC hCompatibleDC;
  HBITMAP hBitmap_graphichgr;    /* Bitmap affchant la zone de slecion */
  DWORD *bitmap_data_graphichgr;

  /* Surchage des Control Edit pour rcuprer les vnements Souris + Entre */
  WNDPROC oldEditProcBank;
  WNDPROC oldEditProcAddress;
  
  /* Mode de rafraichissement de la fentre */
  int refresh_mode;        /* GRAPHICHGR_REFRESH_XXX */
    
  /* Zoom Level */
  int zoom_level;

  /* Posiiton / Taille du Control Group Box */
  int group_data_x;
  int group_data_y;
  int group_data_width;
  int group_data_height;

  /* Position / Taille de la Bitmap HGR Data */
  int bitmap_graphichgr_x;
  int bitmap_graphichgr_y;
  int bitmap_graphichgr_width;   /* 280 */
  int bitmap_graphichgr_height;  /* 192 */

  /** Donnes actuellement affiches **/
  int graphichgr_bank;
  int graphichgr_address;
  unsigned char graphichgr_data[40*192];

  /* Dimension de la fentre = Title + Zone Texte */
  int title_height;
  int window_width;
  int window_height;

  /* Buffer */
  char buffer_log[BUFFER_SIZE];

  /* Notification */
  struct notification *current_notification;

  /* Liste chaine des Graphic HGR */
  struct window_graphichgr *next;
};

struct window_graphichgr *BuildGraphicHGRWindow(HINSTANCE,int);
void mem_free_window_graphichgr(struct window_graphichgr *);

/***************************************************************/
