/******************************************************************************/
/*                                                                            */
/*  Window_GraphicScreen.h :  Header de gestion de la fentre GraphicScreen.  */
/*                                                                            */
/******************************************************************************/
/*  Auteur : Olivier ZARDINI   *   Brutal Deluxe   *   Date :  Janvier 2019   */
/******************************************************************************/

/* Un message destin  la fentre Graphic Screen pour demander la maj de l'affichage */
#define HM_GRAPHICSCREEN_REFRESHWINDOW            (WM_USER + 32)

#define GRAPHICSCREEN_EDIT_FONT_HEIGHT   14    /* Taille de la Fonte en Pixel */

#define GRAPHICSCREEN_DIALOGBOX_WIDTH    417   /* Largeur minimale en Pixel de la fentre */

struct window_graphicscreen
{
  HWND hwnd_graphicscreen;

  /** Graphical element attributes **/
  HDC hDC;
  HDC hCompatibleDC;
  HBITMAP hBitmap_graphicscreen;    /* Bitmap affchant la zone de slecion */
  DWORD *bitmap_data_graphicscreen;

  /* Surchage des Control Edit pour rcuprer les vnements Souris */
  WNDPROC oldEditProcGraphicScreenData;
      
  /* Position / Taille du Control Group Box */
  int group_data_x;
  int group_data_y;
  int group_data_width;
  int group_data_height;

  /* Position / Taille de la Bitmap Screen Data */
  int bitmap_graphicscreen_x;
  int bitmap_graphicscreen_y;
  int bitmap_graphicscreen_width;   /* 640 */
  int bitmap_graphicscreen_height;  /* 200 */

  /* Dimension de la fentre = Title + Zone Texte */
  int title_height;
  int window_width;
  int window_height;

  /* Buffer */
  char buffer_log[BUFFER_SIZE];

  /* Notification */
  struct notification *current_notification;
};

struct window_graphicscreen *BuildGraphicScreenWindow(HINSTANCE,int);
void mem_free_window_graphicscreen(struct window_graphicscreen *);

/***************************************************************/
