/************************************************************************/
/*                                                                      */
/*  Window_LoadFile.h :  Header de gestion de la fentre LoadFile.      */
/*                                                                      */
/************************************************************************/
/*  Auteur : Olivier ZARDINI   *   Brutal Deluxe   *   Date : Dec 2018  */
/************************************************************************/

#define LOADFILE_RAMTYPE_RAM        0
#define LOADFILE_RAMTYPE_DOCRAM     1

struct window_loadfile
{
  HWND hwnd_loadfile;

  DWORD thread_id;              /* Le ThreadID va permettre de diffrencier les diffrentes fentres */

  /* Surchage des Control Edit pour rcuprer les vnements */
  WNDPROC oldEditProcFilePath;
  WNDPROC oldEditProcFileOffset;
  WNDPROC oldEditProcFileLength;
  WNDPROC oldEditProcRamBank;
  WNDPROC oldEditProcRamAddress;

  /* File Data */
  char file_path[1024];
  int file_data_offset;
  int file_data_length;

  /* Ram Location */
  int ram_type;
  int bank;
  int address;
    
  /* Buffer */
  char buffer_log[BUFFER_SIZE];

  /* Liste chaine des Load File */
  struct window_loadfile *next;
};

struct window_loadfile *BuildLoadFileWindow(HINSTANCE,int);
void mem_free_window_loadfile(struct window_loadfile *);

/********************************************************/
