/**********************************************************************/
/*                                                                    */
/*   Window_Main.h :  Header de gestion de la fentre Main.           */
/*                                                                    */
/**********************************************************************/
/*  Auteur : Olivier ZARDINI  *  Brutal Deluxe  *  Date : Avril 2018  */
/**********************************************************************/

/* Un message destin  la fentre Main pour demander la maj de l'affichage */
#define HM_OPERATION_REFRESHWINDOW       (WM_USER + 50)
#define HM_OPERATION_CODE_REFRESHWINDOW  (WM_USER + 51)
#define HM_WINDOW_MAIN_RESET             (WM_USER + 52)

/* Couleur de fond de la Bitmap */
#define BITMAP_BACKGROUND_COLOR MAKECOLOR(101,141,209)    /* Bleu ciel */

/* Couleur de Fond */
#define MAIN_BACKGROUND_COLOR             RGB(230,230,230)

/* */
#define CODE_RICHEDIT_COLOR_BLACK       0   /* Couleurs pour le RichEdit */
#define CODE_RICHEDIT_COLOR_RED         1
#define CODE_RICHEDIT_COLOR_BLUE        2
#define CODE_RICHEDIT_COLOR_GREEN       3
#define CODE_RICHEDIT_COLOR_DARKRED     4
#define CODE_RICHEDIT_COLOR_DARKGREY    5
#define CODE_RICHEDIT_COLOR_PURPLE      6
#define CODE_RICHEDIT_COLOR_PETROL      7
#define CODE_RICHEDIT_COLOR_WHITE       8
#define CODE_RICHEDIT_COLOR_LIGHTGREY   9

/* Taille de la Fentre Main */
#define MAIN_WINDOW_MIN_WIDTH           1333
#define MAIN_WINDOW_MIN_HEIGHT           717+40+40+20+1+10

/* Largeur en Pixel de la bordure de la fentre Windows */
#define WINDOW_BORDER_SIZE                 3

/* Largeur en Pixel de la bordure entre une Group Box et son contenu */
#define WINDOW_GROUP_BORDER_TOP_SIZE      15    /* Tient compte de la hauteur du Titre de la Group Box */
#define WINDOW_GROUP_BORDER_BOTTOM_SIZE    5
#define WINDOW_GROUP_BORDER_LEFT_SIZE      5
#define WINDOW_GROUP_BORDER_RIGHT_SIZE     6

/* Largeur en Pixel autour de Zone Cliente */
#define WINDOW_CLIENT_RIGHT_BORDER_SIZE        11
#define WINDOW_CLIENT_BOTTOM_BORDER_SIZE        7
#define WINDOW_EXTRA_RESIZE_RIGHT_BORDER_SIZE  14    /* Si on active le RESIZE_BORDER, on rajoute de la place  droite */

/* Largeur en Pixel de la bordure des Group Box */
#define WINDOW_GROUP_BORDER_SIZE           5
#define WINDOW_GROUP_BORDER_SIZE           5

/* Cration / Suppression des Timer */
#define HM_NOTIFICATION_TIMER_CREATE       (WM_USER + 256)
#define HM_NOTIFICATION_TIMER_DELETE       (WM_USER + 257)

/* Les 9 Zones de la StatusBar */
#define STATUSBAR_MAIN_CONNECTED           0
#define STATUSBAR_MAIN_APPLEIIGS_ROM       1
#define STATUSBAR_MAIN_MEMORY_SIZE         2
#define STATUSBAR_MAIN_SYMBOL              3
#define STATUSBAR_MAIN_BREAKPOINT          4
#define STATUSBAR_MAIN_OPERATION_SIZE      5
#define STATUSBAR_MAIN_OPERATION_GOID      6
#define STATUSBAR_MAIN_OPERATION_QUEUE     7
#define STATUSBAR_MAIN_STATUS              8

#define STATUSBAR_MAIN_0_WIDTH             200                                /* Etat de la Connexion  KEGS */
#define STATUSBAR_MAIN_1_WIDTH             STATUSBAR_MAIN_0_WIDTH + 55        /* Type de Rom de l'Apple IIgs */
#define STATUSBAR_MAIN_2_WIDTH             STATUSBAR_MAIN_1_WIDTH + 55        /* Taille de la mmoire */
#define STATUSBAR_MAIN_3_WIDTH             STATUSBAR_MAIN_2_WIDTH + 100       /* Nb de Symbol */
#define STATUSBAR_MAIN_4_WIDTH             STATUSBAR_MAIN_3_WIDTH + 120       /* Nb de Breakpoint */
#define STATUSBAR_MAIN_5_WIDTH             STATUSBAR_MAIN_4_WIDTH + 150       /* Taille des Operation Data */
#define STATUSBAR_MAIN_6_WIDTH             STATUSBAR_MAIN_5_WIDTH + 160       /* Operation GOID */
#define STATUSBAR_MAIN_7_WIDTH             STATUSBAR_MAIN_6_WIDTH + 110       /* Operation Queue */
#define STATUSBAR_MAIN_8_WIDTH             -1

#define IDC_GROUPBOX_OPERATION                 1000
#define IDC_EDIT_OPERATION                     1001
#define IDC_STATIC_OPERATION                   1002
#define IDC_BUTTON_OPERATION_CLEAR             1003
#define IDC_BUTTON_OPERATION_RESET_CYCLE       1004
#define IDC_BUTTON_OPERATION_RESET_OPERATION   1005
#define IDC_BUTTON_OPERATION_SAVE              1006
#define IDC_CHECKBOX_OPERATION                 1007

#define IDC_GROUPBOX_CODE                      1008
#define IDC_STATIC_CODE                        1040

#define IDC_STATIC_NB_OPERATION                1041
#define IDC_EDIT_NB_OPERATION                  1042
#define IDC_STATIC_NB_CYCLE                    1043
#define IDC_EDIT_NB_CYCLE                      1044
#define IDC_STATIC_CURRENT_OPERATION_DATA      1045
#define IDC_EDIT_CURRENT_OPERATION_DATA        1046

#define IDC_RICHEDIT_CODE                      1009
#define IDC_BUTTON_CODE_RUN                    1010   /* Run / Stop */
#define IDC_BUTTON_CODE_IN                     1011   /* Step In */
#define IDC_BUTTON_CODE_OVER                   1012   /* Step Over */
#define IDC_BUTTON_CODE_10X                    1013   /* Next 10 */
#define IDC_BUTTON_CODE_100X                   1015   /* Next 100 */
#define IDC_BUTTON_CODE_1000X                  1016   /* Next 1000 */
#define IDC_BUTTON_CODE_10000X                 1017   /* Next 10000 */
#define IDC_BUTTON_CODE_JSR                    1018   /* Next JSR/JSL */
#define IDC_BUTTON_CODE_RTS                    1019   /* Next RTS */
#define IDC_BUTTON_CODE_JMP                    1020   /* Next JMP/Branch */
#define IDC_BUTTON_CODE_VBL                    1021   /* Next VBL */
#define IDC_BUTTON_CODE_INTERRUPT              1022   /* Next Interrupt */
#define IDC_BUTTON_CODE_TOOLBOX                1023   /* Next Toolbox */
#define IDC_BUTTON_CODE_GSOS                   1024   /* Next GS/OS */
#define IDC_BUTTON_CODE_HIGHLIGHT              1025   /* Next Highlight */

#define IDC_GROUPBOX_CALLSTACK                 1026
#define IDC_LISTBOX_CALLSTACK                  1027
#define IDC_BUTTON_CALLSTACK_DISASSEMBLE       1028
#define IDC_BUTTON_CALLSTACK_CLEAR             1029
#define IDC_STATIC_CALLSTACK_ENTRY             1030
#define IDC_STATIC_CALLSTACK_COUNT             1031

#define IDC_GROUPBOX_OUTPUT                    1032
#define IDC_LISTBOX_OUTPUT                     1033
#define IDC_BUTTON_OUTPUT_SAVE                 1034
#define IDC_BUTTON_OUTPUT_CLEAR                1035
#define IDC_BUTTON_OUTPUT_REFRESH              1036
#define IDC_STATIC_OUTPUT_ENTRY                1037
#define IDC_STATIC_OUTPUT_COUNT                1038
#define IDC_CHECKBOX_TRACE_SYSCALL             1039

#define CODE_INTERSPACE_SMALL                    29
#define CODE_INTERSPACE_LARGE                    34

#define BREAKPOINT_INTERSPACE_SMALL              55
#define BREAKPOINT_INTERSPACE_LARGE              65

#define NB_COLUMN_CALLSTACK_OUTPUT               62

#define TRACE_CALL_GOID_OFFSET                    0
#define TRACE_CALL_GOID_LENGTH                   19
#define TRACE_CALL_GCC_OFFSET                    (TRACE_CALL_GOID_LENGTH)
#define TRACE_CALL_GCC_LENGTH                     9
#define TRACE_CALL_PC_ADDRESS_OFFSET             (TRACE_CALL_GOID_LENGTH+TRACE_CALL_GCC_LENGTH)
#define TRACE_CALL_PC_ADDRESS_LENGTH              9
#define TRACE_CALL_CALL_NUMBER_OFFSET            (TRACE_CALL_GOID_LENGTH+TRACE_CALL_GCC_LENGTH+TRACE_CALL_PC_ADDRESS_LENGTH)
#define TRACE_CALL_CALL_NUMBER_LENGTH             6
#define TRACE_CALL_DATA_OFFSET                   (TRACE_CALL_GOID_LENGTH+TRACE_CALL_GCC_LENGTH+TRACE_CALL_PC_ADDRESS_LENGTH+TRACE_CALL_CALL_NUMBER_LENGTH)

#define CODE_RICHEDIT_FONT_HEIGHT_RTF          "16"

#define CYRENE_STATUS_NOT_CONNECTED               0     /* Cyrene n'est conect  Kegs */
#define CYRENE_STATUS_STOPPED_ON_OPERATION        1     /* Cyrene affiche la dernire opration et attend l'oprateur */
#define CYRENE_STATUS_WAIT_FOR_DATA               2     /* Cyrene est entrain de recevoir les donnes de Kegs (Operation + Snapshot) */
#define CYRENE_STATUS_WAIT_FOR_STOP               3     /* On vient d'appuyer sur STOP, Cyrene est en attente des donnes de Kegs (Operation + Snapshot) */

#define MAIN_OPERATION_ROW_HEIGHT                14     /* Hauteur (en Pixel) d'une ligne de la Zone Operation */
#define MAIN_OPERATION_COLUMN_WIDTH               7     /* Largeur (en Pixel) d'un caractre de la Zone Operation */

#define MAIN_OPERATION_NB_ROW                    10     /* Nombre de ligne de donnes dans la Zone Operation au dmarrage */
#define MAIN_OPERATION_NB_COLUMN                179     /* Nombre de colonnes dans la Zone Operation au dmarrage */
#define MAIN_OPERATION_MIN_NB_ROW                 2     /* Nombre de ligne de donnes Minimum dans la Zone Operation */
#define MAIN_OPERATION_MIN_NB_COLUMN            179     /* Nombre de colonnes Minimum dans la Zone Operation */

struct window_main
{
  /* Handles de la fentre Main */
  HWND hwnd_main;
  HWND hwnd_toolbar;
  HWND hwnd_statusbar;
  HMENU hmenu_menu;
  
  /* Brush avec la couleur de Fond */
  HBRUSH hBrush;

  /* Police de caractre */
  HFONT hFont;
  HFONT hFont_courrier;

  /* Mode de retaille de la fentre (user/executable) */
  int user_resize;

  /* Dimension de la fentre  la cration */
  int window_init_width;
  int window_init_height;
  int nb_init_data_row;
  int nb_init_data_column;

  /** Handles / Boutons de la Zone Operation History **/
  int nb_row;                         /* Nombre de lignes actuellement affiches dans la Zone Operation */
  int nb_column;                      /* Nombre de Colonnes actuellement affiches dans la Zone Operation */
  int operation_text_data_column;     /* Nombre de colonnes */
  int operation_text_data_row;        /* Nombre de lignes */
  int operation_text_area_width;      /* Largeur en pixel */
  int operation_text_area_height;     /* Hauteur en pixel */
  int operation_scroll_position;      /* Position du Scroll Vert */
  HWND hwnd_groupbox_operation;
  HWND hwnd_edit_operation;
  HWND hwnd_scrollbar_operation;
  HWND hwnd_static_operation;
  BOOL button_operation_status;
  HWND hwnd_button_operation_reset_operation;
  HWND hwnd_button_operation_reset_cycle;
  HWND hwnd_button_operation_save;
  HWND hwnd_button_operation_clear;
  HWND hwnd_checkbox_history_operation;
  int operation_history_checkbox;     /* 0:On n'historise pas, 1:On historise */
  HWND hwnd_static_operation_count;
  HWND hwnd_edit_operation_count;
  HWND hwnd_static_cycle_count;
  HWND hwnd_edit_cycle_count;
  HWND hwnd_static_operation_data;
  HWND hwnd_edit_operation_data;
  DWORD latest_refresh_operation_td;  /* Horodatage de la dernire MAJ des operations */

  /** Handles / Boutons de la Zone Code Disassembly **/
  int code_status;      /* CYRENE_STATUS_XXX */
  int code_x0;
  int code_y0;
  HWND hwnd_groupbox_code;
  HWND hwnd_static_code;
  HWND hwnd_richedit_code;
  HWND hwnd_button_code_run;
  HWND hwnd_button_code_in;
  HWND hwnd_button_code_over;
  HWND hwnd_button_code_10x;
  HWND hwnd_button_code_100x;
  HWND hwnd_button_code_1000x;
  HWND hwnd_button_code_10000x;
  HWND hwnd_button_code_jmp;
  HWND hwnd_button_code_rts;
  HWND hwnd_button_code_jsr;
  HWND hwnd_button_code_vbl;
  HWND hwnd_button_code_interrupt;
  HWND hwnd_button_code_toolbox;
  HWND hwnd_button_code_gsos;
  HWND hwnd_button_code_highlight;
  int acc_code_run;                   /* Activation des touches Accelerateur */
  int acc_code_next;
  int acc_code_over;
  int acc_code_highlight;
  int nb_code_line;
  int tab_code_line_address[256];     /* Address de la ligne */
  int tab_code_line_m[256];           /* MX de la ligne */
  int tab_code_line_x[256];
  char *tab_code_line_ascii[256];     /* Ligne Text */
  char *tab_code_line_color[256];     /* Ligne Rich Text */
  int code_current_line;              /* Numro de la ligne en cours 0-N */
  int code_selected_line;             /* Numro de la ligne slectionne 0-N */
  int code_current_line_is_jsr;       /* La ligne actuelle est un JSR/JSL */
  int rtf_data_code_size;
  int rtf_write_code_offset;
  char rtf_data_code[8192];

  /** Handles / Boutons de la Zone Call Stack **/
  int callstack_x0;
  int callstack_y0;
  HWND hwnd_groupbox_callstack;
  HWND hwnd_listbox_callstack;
  HWND hwnd_button_callstack_disassemble;
  HWND hwnd_button_callstack_clear;
  HWND hwnd_static_callstack_entry;
  HWND hwnd_static_callstack_count;   /* Nombre d'entres affiches dans la Liste */
  int nb_callstack;
  struct callstack *first_callstack;
  struct callstack *last_callstack;

  /** Handles / Boutons de la Zone Output **/
  int output_x0;
  int output_y0;
  HWND hwnd_groupbox_output;
  HWND hwnd_listbox_output;
  HWND hwnd_button_output_save;
  HWND hwnd_button_output_clear;
  HWND hwnd_button_output_refresh;
  HWND hwnd_static_output_entry;
  HWND hwnd_static_output_count;      /* Nombre d'entres affiches dans la Liste */
  HWND hwnd_checkbox_trace_syscall;   /* Demande la Trace des Appels Systmes */
  int output_trace_syscall;           /* Demande la Trace des Appels Systmes */
  int nb_output;
  struct output *first_output;
  struct output *last_output;
  DWORD latest_refresh_output_td;     /* Horodatage de la dernire MAJ des output */

  /** La Table des Symbol est rattache  la fentre Main pour ne pas la perdre **/
  struct symbol_table *current_symbol_table;

  /** La Table des Breakpoint est rattache  la fentre Main pour ne pas la perdre **/
  struct breakpoint_table *current_breakpoint_table;

  /** La Table des Statistic est rattache  la fentre Main pour ne pas la perdre **/
  struct statistic_table *current_statistic_table;

  /** La Table des Profile est rattache  la fentre Main pour ne pas la perdre **/
  struct profile_table *current_profile_table;

  /** La Table des QuickWatch est rattache  la fentre Main pour ne pas la perdre **/
  struct quickwatch_data tab_quickwatch_data[10];

  /** Stop Condition **/
  BYTE stop_condition;              /* */
  DWORD stop_breakpoint_id;

  /* Hauteur du Menu en Pixel */
  int title_menu_height;

  /* Hauteur de la Toolbar en Pixel */
  int toolbar_height;

  /* Hauteur de la Status Bar en Pixel */
  int statusbar_height;

  /* Taille de la Fentre */
  int window_main_width;
  int window_main_height;

  /* Log du Process */
  char buffer_log[1024];
};

struct callstack
{
  /** Point d'entre de cette fonction **/
  DWORD function_address;         /* Adresse de base de la fonction en cours = Jump Address de la callstack prcdente */
  WORD call_number;               /* Complment d'appel  la fonction Tool / GS/OS pour nommer la fonction */
  QWORD gcc;                      /* Global Cycle Count */
  QWORD goid;                     /* Global Operation ID */
  DWORD function_end_address;     /* Adresse de retour de fin de cette fonction (0xFFFFFFFF si ROOT) */
  int is_interrupt;               /* On vient de rentrer dans une interruption */
  int depth;                      /* Niveau de profondeur des appels 0-N */
  int function_under_interrupt;   /* Cette fonction est appele sous interruption (la fonction qui appelle celle-ci est sous interruption) */

  /** Opration en cours **/
  QWORD operation_goid;           /* Global Operation ID */
  QWORD operation_gcc;            /* Global Cycle Count */
  DWORD operation_pc_address;     /* Adresse de cette opration (adresse d'o on saute) */
  BYTE operation_opcode;          /* Operation (JSR/JSL/...) */
  int operation_operand_size;     /* 0/1/2/3 */
  BYTE operation_operand[3];      /* Operande */
  DWORD operation_jump_address;   /* Adresse o on va sauter (si JSR/JSL) */
  WORD operation_call_number;     /* Information complmentaire pour dterminer le nom de la fonction Toolbox | GS/OS */

  struct callstack *next;
  struct callstack *previous;
};

int BuildMainWindow(HINSTANCE);
void UpdateWindowMainStatusBar(void);
int ProcessOperationButton(struct window_main *,int);
void ProcessCallStackOperation(struct window_main *,int);
void RefreshOutputListBox(struct window_main *);
void mem_free_window_main(struct window_main *);

/**********************************************************************/
