/************************************************************************/
/*                                                                      */
/*  Window_MemoryArea.h :  Header de gestion de la fentre MemoryArea.  */
/*                                                                      */
/************************************************************************/
/*  Auteur : Olivier ZARDINI  *   Brutal Deluxe   *   Date : Juin 2018  */
/************************************************************************/

/* Un message destin  la fentre Memory Area pour demander la maj de l'affichage */
#define HM_MEMORYAREA_REFRESHWINDOW   (WM_USER + 22)
#define HM_MEMORYAREA_REFRESHSYMBOL   (WM_USER + 23)
#define IDC_EDIT_MEMORYAREA_DATA      1623

#define MEMORYAREA_REFRESH_AUTOMATIC  0
#define MEMORYAREA_REFRESH_MANUAL     1

#define MEMORYAREA_EDIT_FONT_WIDTH     7    /* Taille de la Fonte en Pixel */
#define MEMORYAREA_EDIT_FONT_HEIGHT   14

struct window_memoryarea
{
  HWND hwnd_memoryarea;
  HWND hwnd_edit_data;          /* Control Text Multi Ligne */
  HFONT hFont;

  DWORD thread_id;              /* Le ThreadID va permettre de diffrencier les diffrentes fentres */

  /* Surchage des Control Edit pour rcuprer les vnements Souris + Entre */
  WNDPROC oldEditProcMemoryAreaData;
  WNDPROC oldEditProcBank;
  WNDPROC oldEditProcAddress;
  WNDPROC oldEditProcColumn;
  WNDPROC oldEditProcRow;

  /* Mode de rafraichissement de la fentre */
  int refresh_mode;        /* MEMORYAREA_REFRESH_XXX */

  /* Mode de retaille de la fentre (user/executable) */
  int user_resize;

  /* Etat courrant de la fentre AVANT le Resize User */
  int window_metric_width;
  int window_metric_height;
  int window_metric_column;
  int window_metric_row;

  /* Posiiton / Taille du Control Group Box */
  int group_data_x;
  int group_data_y;
  int group_data_width;
  int group_data_height;

  /* Position / Taille du Control Text Zone MemoryArea Data */
  int memoryarea_data_x;
  int memoryarea_data_y;
  int memoryarea_data_width;
  int memoryarea_data_height;

  /** Control Edit : Zone Texte o sont affiches les Data **/   
  int text_data_column;            /* Nombre de colonne Data */
  int text_data_row;               /* Nombre de ligne Data */
  int text_data_width;             /* "00/0000___00_00_00_00_00_00_00_00.00_00_00_00_00_00_00_00__ASCII\r\n" */
  int text_data_size;              /* text_data_width*column */
  char *text_data_hexadecimal;     /* Zone Texte column*line */ 

  /* Taille Minimale */
  int text_min_data_column;        /* Valeur Minimale autorise pour text_data_column */
  int text_min_data_row;           /* Valeur Minimale autorise pour text_data_row */

  /** Donnes actuellement affiches **/
  DWORD init_address;              /* Adresse de Base */
  int memoryarea_bank;
  int memoryarea_address;
  int nb_column;
  int nb_row;
  unsigned char *memoryarea_data;

  /* Dimension de la fentre = Title + Zone Texte */
  int title_height;
  int window_width;
  int window_height;
  
  /** Symbol **/
  int has_symbol;
  char symbol_name[1024];
  char symbol_segment[1024];
  char symbol_file[1024];
  DWORD symbol_address;

  /* Buffer */
  char buffer_log[BUFFER_SIZE];

  /* Notification */
  struct notification *current_notification;

  /* Liste chaine des Memory Area */
  struct window_memoryarea *next;
};

struct window_memoryarea *BuildMemoryAreaWindow(HINSTANCE,int,DWORD);
void mem_free_window_memoryarea(struct window_memoryarea *);

/********************************************************/
