/*********************************************************************/
/*                                                                   */
/*  Window_Modify.h :  Header de gestion de la fentre Modify.       */
/*                                                                   */
/*********************************************************************/
/*  Auteur : Olivier ZARDINI  *  Brutal Deluxe  *  Date : Janv 2019  */
/*********************************************************************/

/* Un message destin  la fentre Modify pour demander la maj de l'affichage */
#define IDC_EDIT_MODIFY_DATA               1840

#define IDC_COMBOBOX_MODIFY_DATALENGTH_1   1801
#define IDC_COMBOBOX_MODIFY_DATALENGTH_2   1802
#define IDC_COMBOBOX_MODIFY_DATALENGTH_3   1803
#define IDC_COMBOBOX_MODIFY_DATALENGTH_4   1804
#define IDC_COMBOBOX_MODIFY_DATALENGTH_5   1805

#define MODIFY_EDIT_FONT_HEIGHT   14    /* Taille de la Fonte en Pixel */

#define MODIFY_MODE_BYTE           0
#define MODIFY_MODE_PATTERN        1

#define MODIFY_RAMTYPE_RAM         0
#define MODIFY_RAMTYPE_DOCRAM      1

#define MODIFY_ALIGNMENT_INTEL     0
#define MODIFY_ALIGNMENT_MOTOROLA  1

#define MODIFY_LENGTH_8            1
#define MODIFY_LENGTH_16           2
#define MODIFY_LENGTH_24           3
#define MODIFY_LENGTH_32           4

#define MODIFY_COMBO_8             0
#define MODIFY_COMBO_16_INTEL      1
#define MODIFY_COMBO_24_INTEL      2
#define MODIFY_COMBO_32_INTEL      3
#define MODIFY_COMBO_16_MOTOROLA   4
#define MODIFY_COMBO_24_MOTOROLA   5
#define MODIFY_COMBO_32_MOTOROLA   6

#define MODIFY_VALUE_UNKNOWN       0
#define MODIFY_VALUE_BYTE          1
#define MODIFY_VALUE_PATTERN       2

struct modify_value
{
  int type;

  /* Byte */
  unsigned char byte;

  /* Pattern */
  int value;
  struct modify_pattern *pattern;

  /* Text */
  char value_txt[1024];

  struct modify_value *next;
};

struct modify_pattern
{
  char name[256];

  int combo_length_alignment;  /* Valeur du Combo */
  int data_length;             /* MODIFY_LENGTH_XXX */
  int data_alignment;          /* MODIFY_ALIGNMENT_XXX */

  int value;
  int increment;

  int is_data_error;           /* L'adresse n'est pas valide */

  int in_use;                  /* Cette Pattern est utilise dans les Data Byte */
};

struct window_modify
{
  HWND hwnd_modify;
  HFONT hFont_conbo;

  DWORD thread_id;              /* Le ThreadID va permettre de diffrencier les diffrentes fentres */

  /** Surcharge des Control Edit **/
  WNDPROC oldEditProcBank;
  WNDPROC oldEditProcAddress;
  WNDPROC oldEditProcData;
  WNDPROC oldEditProcRepeat;
  WNDPROC oldEditProcName1;
  WNDPROC oldEditProcName2;
  WNDPROC oldEditProcName3;
  WNDPROC oldEditProcName4;
  WNDPROC oldEditProcName5;
  WNDPROC oldEditProcValue1;
  WNDPROC oldEditProcValue2;
  WNDPROC oldEditProcValue3;
  WNDPROC oldEditProcValue4;
  WNDPROC oldEditProcValue5;
  WNDPROC oldEditProcIncrement1;
  WNDPROC oldEditProcIncrement2;
  WNDPROC oldEditProcIncrement3;
  WNDPROC oldEditProcIncrement4;
  WNDPROC oldEditProcIncrement5;
  
  /** ComboBox Data Length / Alignment **/
  HWND hwnd_combo_length_alignment1;
  HWND hwnd_combo_length_alignment2;
  HWND hwnd_combo_length_alignment3;
  HWND hwnd_combo_length_alignment4;
  HWND hwnd_combo_length_alignment5;

  int mode;                    /* MODIFY_MODE_XXX */
  int ram_type;                /* MODIFY_RAMTYPE_XXX */
  int bank;
  int address;
  char data[1024];

  /** Pattern **/
  struct modify_pattern tab_pattern[5];

  /* Buffer */
  char buffer_log[BUFFER_SIZE];
  
  /* Liste chaine des Modify */
  struct window_modify *next;
};

struct window_modify *BuildModifyWindow(HINSTANCE,int);
void mem_free_window_modify(struct window_modify *);

/********************************************************/
