/*********************************************************************/
/*                                                                   */
/*  Window_Move.h :  Header de gestion de la fentre Move.           */
/*                                                                   */
/*********************************************************************/
/*  Auteur : Olivier ZARDINI  *  Brutal Deluxe  *  Date : Janv 2019  */
/*********************************************************************/

/* Un message destin  la fentre Move pour demander la maj de l'affichage */
#define IDC_EDIT_MOVE_DATA                 1940

#define MOVE_RAMTYPE_RAM         0
#define MOVE_RAMTYPE_DOCRAM      1

struct window_move
{
  HWND hwnd_move;

  DWORD thread_id;              /* Le ThreadID va permettre de diffrencier les diffrentes fentres */

  /** Surcharge des Control Edit **/
  WNDPROC oldEditProcBank1;
  WNDPROC oldEditProcBank2;
  WNDPROC oldEditProcAddress1;
  WNDPROC oldEditProcAddress2;
  WNDPROC oldEditProcLength;

  int ram_type1;                /* MOVE_RAMTYPE_XXX */
  int bank1;
  int address1;
  int ram_type2;                /* MOVE_RAMTYPE_XXX */
  int bank2;
  int address2;

  int length;

  /* Buffer */
  char buffer_log[BUFFER_SIZE];
  
  /* Liste chaine des Move */
  struct window_move *next;
};

struct window_move *BuildMoveWindow(HINSTANCE,int);
void mem_free_window_move(struct window_move *);

/********************************************************/
