/*************************************************************************/
/*                                                                       */
/*   Window_Preference.h :  Header de gestion de la fentre Preference.  */
/*                                                                       */
/*************************************************************************/
/*  Auteur : Olivier ZARDINI   *   Brutal Deluxe   *   Date : Juin 2024  */
/*************************************************************************/

/* Un message destin  la fentre Processor pour demander la maj de l'affichage */
#define IDC_EDIT_PROCESSOR_DATA      1625

#define PROCESSOR_EDIT_FONT_HEIGHT   14    /* Taille de la Fonte en Pixel */

struct window_preference
{
  HWND hwnd_preference;
  HWND hwnd_tabcontrol;
  HFONT hFont;

  /* Brush avec la couleur de Fond */
  HBRUSH hBrush;

  /* Surchage des Control Edit pour rcuprer les vnements Clavier + Souris */
  WNDPROC oldEditProcBreakpoint;
  WNDPROC oldEditProcQuickwatch;
  WNDPROC oldEditProcSymbol1;
  WNDPROC oldEditProcSymbol2;
  WNDPROC oldEditProcSymbol3;
  WNDPROC oldEditProcSymbol4;
  WNDPROC oldEditProcSymbol5;
  WNDPROC oldEditProcIgnoreOsCall;
  WNDPROC oldEditProcTraceOsCall;
  WNDPROC oldEditProcIgnoreToolboxCall;
  WNDPROC oldEditProcTraceToolboxCall;

  /** Donne actuellement affiche **/
  int reload_at_startup;
  char breakpoint_file_path[1024];
  char quickwatch_file_path[1024];
  char symbol1_file_path[1024];
  char symbol2_file_path[1024];
  char symbol3_file_path[1024];
  char symbol4_file_path[1024];
  char symbol5_file_path[1024];

  /* On ne va pas tracer les appels gs/os DInfo et DStatus => param */

  /* Buffer */
  char buffer_log[BUFFER_SIZE];
};

struct window_preference *BuildPreferenceWindow(HINSTANCE,int);
void LoadInitPreferenceFiles(void);
void mem_free_window_preference(struct window_preference *);

/************************************************************************/
