/************************************************************************/
/*                                                                      */
/*  Window_Processor.h :  Header de gestion de la fentre Processor.    */
/*                                                                      */
/************************************************************************/
/*  Auteur : Olivier ZARDINI  *   Brutal Deluxe   *   Date : Juin 2018  */
/************************************************************************/

/* Un message destin  la fentre Processor pour demander la maj de l'affichage */
#define HM_PROCESSOR_REFRESHWINDOW   (WM_USER + 24)
#define IDC_EDIT_PROCESSOR_DATA      1625

#define PROCESSOR_REFRESH_AUTOMATIC  0
#define PROCESSOR_REFRESH_MANUAL     1

#define PROCESSOR_EDIT_FONT_HEIGHT   14    /* Taille de la Fonte en Pixel */

struct window_processor
{
  HWND hwnd_processor;
  HFONT hFont;
  
  /* Mode de rafraichissement de la fentre */
  int refresh_mode;        /* PROCESSOR_REFRESH_XXX */

  /** Donne actuellement affiche **/
  /* Register */
  WORD proc_a;
  WORD proc_x;
  WORD proc_y;
  BYTE proc_dbr;
  BYTE proc_pbr;
  WORD proc_pc;
  WORD proc_stack;
  WORD proc_directpage;

  /* Status Register */
  int status_c;
  int status_z;
  int status_i;
  int status_d;
  int status_x;
  int status_m;
  int status_v;
  int status_n;
  int status_e;
  int status_b;
  
  /* Banc de la Page Directe et de la Stack */
  BYTE directpage_stack_bank;    /* $00/ ou $01/ */
  
  /* Buffer */
  char buffer_log[BUFFER_SIZE];
  
  /* Notification */
  struct notification *current_notification;
};

struct window_processor *BuildProcessorWindow(HINSTANCE,int);
void mem_free_window_processor(struct window_processor *);

/********************************************************/
