/************************************************************************/
/*                                                                      */
/*   Window_Project.h :  Header de gestion de la fentre Project.       */
/*                                                                      */
/************************************************************************/
/*  Auteur : Olivier ZARDINI  *   Brutal Deluxe   *  Date : Avril 2018  */
/************************************************************************/

struct window_project
{
  HWND hwnd_project;
  HWND hwnd_combo_text_color;           /* ComboBox pour le Text Color */
  HWND hwnd_combo_background_color;     /* ComboBox pour le Background Color */
  HWND hwnd_combo_border_color;         /* ComboBox pour le Border Color */
  HFONT hFont;

  /* Type de fentre souhaite : New|Open|Edit|SaveAs Project */
  int menu_id;

  /** Surcharge des Control Edit **/
  WNDPROC oldEditProcProcA;
  WNDPROC oldEditProcProcX;
  WNDPROC oldEditProcProcY;
  WNDPROC oldEditProcProcDBR;
  WNDPROC oldEditProcProcPBR;
  WNDPROC oldEditProcProcPC;
  WNDPROC oldEditProcProcStack;
  WNDPROC oldEditProcProcDPage;
  WNDPROC oldEditProcStatusC;
  WNDPROC oldEditProcStatusZ;
  WNDPROC oldEditProcStatusI;
  WNDPROC oldEditProcStatusD;
  WNDPROC oldEditProcStatusX;
  WNDPROC oldEditProcStatusM;
  WNDPROC oldEditProcStatusV;
  WNDPROC oldEditProcStatusN;
  WNDPROC oldEditProcStatusE;
  WNDPROC oldEditProcStatusB;
  WNDPROC oldEditProcRamSize;
  WNDPROC oldEditProcFile0Bank;
  WNDPROC oldEditProcFile0Address;
  WNDPROC oldEditProcFile0Path;
  WNDPROC oldEditProcFile1Bank;
  WNDPROC oldEditProcFile1Address;
  WNDPROC oldEditProcFile1Path;
  WNDPROC oldEditProcFile2Bank;
  WNDPROC oldEditProcFile2Address;
  WNDPROC oldEditProcFile2Path;
  WNDPROC oldEditProcFile3Bank;
  WNDPROC oldEditProcFile3Address;
  WNDPROC oldEditProcFile3Path;
  WNDPROC oldEditProcFile4Bank;
  WNDPROC oldEditProcFile4Address;
  WNDPROC oldEditProcFile4Path;
  WNDPROC oldEditProcFile5Bank;
  WNDPROC oldEditProcFile5Address;
  WNDPROC oldEditProcFile5Path;
  WNDPROC oldEditProcFile6Bank;
  WNDPROC oldEditProcFile6Address;
  WNDPROC oldEditProcFile6Path;
  WNDPROC oldEditProcFile7Bank;
  WNDPROC oldEditProcFile7Address;
  WNDPROC oldEditProcFile7Path;
  WNDPROC oldEditProcFile8Bank;
  WNDPROC oldEditProcFile8Address;
  WNDPROC oldEditProcFile8Path;
  WNDPROC oldEditProcFileSoundAddress;
  WNDPROC oldEditProcFileSoundPath;
  WNDPROC oldEditProcFileMerlin32Path;

  /* Projet charg en mmoire */
  struct project *current_project;

  /** Files **/
  BYTE file0_bank;
  WORD file0_address;
  char file0_path[BUFFER_SIZE];
  BYTE file1_bank;
  WORD file1_address;
  char file1_path[BUFFER_SIZE];
  BYTE file2_bank;
  WORD file2_address;
  char file2_path[BUFFER_SIZE];
  BYTE file3_bank;
  WORD file3_address;
  char file3_path[BUFFER_SIZE];
  BYTE file4_bank;
  WORD file4_address;
  char file4_path[BUFFER_SIZE];
  BYTE file5_bank;
  WORD file5_address;
  char file5_path[BUFFER_SIZE];
  BYTE file6_bank;
  WORD file6_address;
  char file6_path[BUFFER_SIZE];
  BYTE file7_bank;
  WORD file7_address;
  char file7_path[BUFFER_SIZE];
  BYTE file8_bank;
  WORD file8_address;
  char file8_path[BUFFER_SIZE];

  /** File Sound **/
  WORD file_sound_address;
  char file_sound_path[BUFFER_SIZE];

  /** Merlin 32 output files **/
  char file_merlin32_path[BUFFER_SIZE];
  
  /* Processor */
  WORD proc_a;
  WORD proc_x;
  WORD proc_y;
  BYTE proc_dbr;
  BYTE proc_pbr;
  WORD proc_pc;
  WORD proc_stack;
  WORD proc_directpage;

  /* Status Register */
  int status_c;
  int status_z;
  int status_i;
  int status_d;
  int status_x;
  int status_m;
  int status_v;
  int status_n;
  int status_e;
  int status_b;  

  /* RAM Size */
  int ram_size;               /* Nombre de bank mmoire en plus des 256 KB de base */

  /* Apple II ROM */
  int appleii_rom;

  /* Apple IIgs ROM */
  int appleiigs_rom;          /* PROJECT_APPLEIIGS_XXX */

  /* Display Preferences */
  int color_text;
  int color_background;
  int color_border;

  /* Log du Process */
  char buffer_log[1024];
};

struct window_project *BuildProjectWindow(HINSTANCE,int,char *);
void mem_free_window_project(struct window_project *);

/**********************************************************************/
