/************************************************************************/
/*                                                                      */
/*  Window_QuickWatch.h :  Header de gestion de la fentre QuickWatch.  */
/*                                                                      */
/************************************************************************/
/*  Auteur : Olivier ZARDINI  *   Brutal Deluxe   *   Date : Janv 2019  */
/************************************************************************/

/* Un message destin  la fentre QuickWatch pour demander la maj de l'affichage */
#define HM_QUICKWATCH_REFRESHWINDOW            (WM_USER + 24)
#define HM_QUICKWATCH_REFRESHSYMBOL1           (WM_USER + 25)
#define HM_QUICKWATCH_REFRESHSYMBOL2           (WM_USER + 26)
#define HM_QUICKWATCH_REFRESHSYMBOL3           (WM_USER + 27)
#define HM_QUICKWATCH_REFRESHSYMBOL4           (WM_USER + 28)
#define HM_QUICKWATCH_REFRESHSYMBOL5           (WM_USER + 29)
#define HM_QUICKWATCH_REFRESHSYMBOL6           (WM_USER + 30)
#define HM_QUICKWATCH_REFRESHSYMBOL7           (WM_USER + 31)
#define HM_QUICKWATCH_REFRESHSYMBOL8           (WM_USER + 32)
#define HM_QUICKWATCH_REFRESHSYMBOL9           (WM_USER + 33)
#define HM_QUICKWATCH_REFRESHSYMBOL10          (WM_USER + 34)
#define IDC_EDIT_QUICKWATCH_DATA               1640

#define IDC_COMBOBOX_QUICKWATCH_DATALENGTH_1   1701
#define IDC_COMBOBOX_QUICKWATCH_DATALENGTH_2   1702
#define IDC_COMBOBOX_QUICKWATCH_DATALENGTH_3   1703
#define IDC_COMBOBOX_QUICKWATCH_DATALENGTH_4   1704
#define IDC_COMBOBOX_QUICKWATCH_DATALENGTH_5   1705
#define IDC_COMBOBOX_QUICKWATCH_DATALENGTH_6   1706
#define IDC_COMBOBOX_QUICKWATCH_DATALENGTH_7   1707
#define IDC_COMBOBOX_QUICKWATCH_DATALENGTH_8   1708
#define IDC_COMBOBOX_QUICKWATCH_DATALENGTH_9   1709
#define IDC_COMBOBOX_QUICKWATCH_DATALENGTH_10  1710

#define QUICKWATCH_REFRESH_AUTOMATIC   0
#define QUICKWATCH_REFRESH_MANUAL      1

#define QUICKWATCH_EDIT_FONT_HEIGHT   14    /* Taille de la Fonte en Pixel */

#define QUICKWATCH_RAMTYPE_RAM         0
#define QUICKWATCH_RAMTYPE_DOCRAM      1

#define QUICKWATCH_ALIGNMENT_INTEL     0
#define QUICKWATCH_ALIGNMENT_MOTOROLA  1

#define QUICKWATCH_LENGTH_8            1
#define QUICKWATCH_LENGTH_16           2
#define QUICKWATCH_LENGTH_24           3
#define QUICKWATCH_LENGTH_32           4

#define QUICKWATCH_COMBO_8             0
#define QUICKWATCH_COMBO_16_INTEL      1
#define QUICKWATCH_COMBO_24_INTEL      2
#define QUICKWATCH_COMBO_32_INTEL      3
#define QUICKWATCH_COMBO_16_MOTOROLA   4
#define QUICKWATCH_COMBO_24_MOTOROLA   5
#define QUICKWATCH_COMBO_32_MOTOROLA   6

struct quickwatch_data
{
  int ram_type;                /* QUICKWATCH_RAMTYPE_XXX */

  BYTE bank;                   /* Adresse de la Valeur */
  WORD address;
  int is_data_error;           /* L'adresse n'est pas valide */

  int combo_length_alignment;  /* Valeur du Combo */
  int data_length;             /* QUICKWATCH_LENGTH_XXX */
  int data_alignment;          /* QUICKWATCH_ALIGNMENT_XXX */
  unsigned char data[4];

  char name[1024];             /* Label de l'adresse */

  int has_symbol;              /* Symbol */
  char symbol_name[1024];
  char symbol_segment[1024];
  char symbol_file[1024];
  DWORD symbol_address;
};

struct window_quickwatch
{
  HWND hwnd_quickwatch;
  HFONT hFont_value;
  HFONT hFont_conbo;

  /** Surcharge des Control Edit **/
  WNDPROC oldEditProcBank1;
  WNDPROC oldEditProcBank2;
  WNDPROC oldEditProcBank3;
  WNDPROC oldEditProcBank4;
  WNDPROC oldEditProcBank5;
  WNDPROC oldEditProcBank6;
  WNDPROC oldEditProcBank7;
  WNDPROC oldEditProcBank8;
  WNDPROC oldEditProcBank9;
  WNDPROC oldEditProcBank10;
  WNDPROC oldEditProcAddress1;
  WNDPROC oldEditProcAddress2;
  WNDPROC oldEditProcAddress3;
  WNDPROC oldEditProcAddress4;
  WNDPROC oldEditProcAddress5;
  WNDPROC oldEditProcAddress6;
  WNDPROC oldEditProcAddress7;
  WNDPROC oldEditProcAddress8;
  WNDPROC oldEditProcAddress9;
  WNDPROC oldEditProcAddress10;
  WNDPROC oldEditProcLabel1;
  WNDPROC oldEditProcLabel2;
  WNDPROC oldEditProcLabel3;
  WNDPROC oldEditProcLabel4;
  WNDPROC oldEditProcLabel5;
  WNDPROC oldEditProcLabel6;
  WNDPROC oldEditProcLabel7;
  WNDPROC oldEditProcLabel8;
  WNDPROC oldEditProcLabel9;
  WNDPROC oldEditProcLabel10;

  /** ComboBox Data Length / Alignment **/
  HWND tab_hwnd_combo_length_alignment[10];

  /* Mode de rafraichissement de la fentre */
  int refresh_mode;              /* QUICKWATCH_REFRESH_XXX */

  /* Buffer */
  char buffer_log[BUFFER_SIZE];
  
  /* Notification */
  struct notification *current_notification;
};

struct window_quickwatch *BuildQuickWatchWindow(HINSTANCE,int);
void LoadQuickWatchDataFile(char *,struct window_quickwatch *);
void UpdateQuickWatchSymbolAddress(void);
void UpdateQuickWatchRamType(struct window_quickwatch *,int,int,int);
void RefreshQuickWatchWindowData(struct window_quickwatch *);
void RefreshQuickWatchWindow(struct window_quickwatch *);
void mem_free_window_quickwatch(struct window_quickwatch *);

/********************************************************/
