/*********************************************************************/
/*                                                                   */
/*  Window_RamSound.h :  Header de gestion de la fentre RamSound.   */
/*                                                                   */
/*********************************************************************/
/*  Auteur : Olivier ZARDINI  *  Brutal Deluxe  *  Date : Juin 2018  */
/*********************************************************************/

/* Un message destin  la fentre Ram Sound pour demander la maj de l'affichage */
#define HM_RAMSOUND_REFRESHWINDOW   (WM_USER + 23)
#define IDC_RICHEDIT_RAMSOUND_DATA  1624

#define RAMSOUND_REFRESH_AUTOMATIC  0
#define RAMSOUND_REFRESH_MANUAL     1

#define RAMSOUND_EDIT_FONT_WIDTH     7    /* Taille de la Fonte en Pixel */
#define RAMSOUND_EDIT_FONT_HEIGHT   14    /* Taille de la Fonte en Pixel */

#define RAMSOUND_RICHEDIT_FONT_HEIGHT     14    /* Taille de la Fonte en Pixel */
#define RAMSOUND_RICHEDIT_FONT_HEIGHT_RTF "16"  /* Taille de la Fonte dans le RTF */

struct window_ramsound
{
  HWND hwnd_ramsound;
  HWND hwnd_richedit_data;      /* Control Rich Text Multi Line */
  HFONT hFont;  

  DWORD thread_id;              /* Le ThreadID va permettre de diffrencier les diffrentes fentres */

  /* Surchage des Control Edit pour rcuprer les vnements Clavier + Souris */
  WNDPROC oldEditProcRamSoundData;
  WNDPROC oldEditProcAddress;
  WNDPROC oldEditProcColumn;
  WNDPROC oldEditProcRow;

  /* Mode de rafraichissement de la fentre */
  int refresh_mode;        /* RAMSOUND_REFRESH_XXX */

  /* Mode de retaille de la fentre (user/executable) */
  int user_resize;

  /* Etat courrant de la fentre AVANT le Resize User */
  int window_metric_width;
  int window_metric_height;
  int window_metric_column;
  int window_metric_row;

  /* Position / Taille du Control Group Box */
  int group_data_x;
  int group_data_y;
  int group_data_width;
  int group_data_height;

  /* Position / Taille du Control Text Zone RamSound Data */
  int ramsound_data_x;
  int ramsound_data_y;
  int ramsound_data_width;
  int ramsound_data_height;

  /** Control Edit : Zone Texte o sont affiches les Data **/   
  int text_data_column;            /* Nombre de colonne Data */
  int text_data_row;               /* Nombre de ligne Data */
  int text_data_width;             /* "00/0000___00_00_00_00_00_00_00_00.00_00_00_00_00_00_00_00__ASCII\r\n" */
  int rtf_data_size;               /* Taille de la Zone Texte RTF */
  char *rtf_data_hexadecimal;      /* Zone Texte RTF */  
  int rtf_write_offset;            /* Offset de l'criture de la Zone Texte RTF vers le Rich Edit */

  /* Taille Minimale */
  int text_min_data_column;        /* Valeur Minimale autorise pour text_data_column */
  int text_min_data_row;           /* Valeur Minimale autorise pour text_data_row */

  /** Donnes actuellement affiches **/
  int ramsound_address;
  int nb_column;
  int nb_row;
  unsigned char *ramsound_data;

  /* Dimension de la fentre = Title + Zone Texte */
  int title_height;
  int window_width;
  int window_height;
  
  /* Buffer */
  char buffer_log[BUFFER_SIZE];

  /* Notification */
  struct notification *current_notification;

  /* Liste chaine des Ram Sound */
  struct window_ramsound *next;
};

struct window_ramsound *BuildRamSoundWindow(HINSTANCE,int);
void mem_free_window_ramsound(struct window_ramsound *);

/********************************************************/
