/************************************************************************/
/*                                                                      */
/*  Window_SaveMemory.h :  Header de gestion de la fentre SaveMemory.  */
/*                                                                      */
/************************************************************************/
/*  Auteur : Olivier ZARDINI   *   Brutal Deluxe   *   Date : Jan 2019  */
/************************************************************************/

#define SAVEMEMORY_RAMTYPE_RAM        0
#define SAVEMEMORY_RAMTYPE_DOCRAM     1

#define SAVEMEMORY_FILEMODE_NEW       0
#define SAVEMEMORY_FILEMODE_APPEND    1

struct window_savememory
{
  HWND hwnd_savememory;

  DWORD thread_id;              /* Le ThreadID va permettre de diffrencier les diffrentes fentres */

  /* Surchage des Control Edit pour rcuprer les vnements */
  WNDPROC oldEditProcRamBank;
  WNDPROC oldEditProcRamAddress;  
  WNDPROC oldEditProcDataLength;
  WNDPROC oldEditProcFilePath;

  /* Ram Location + Length */
  int ram_type;                  /* SAVEMEMORY_RAMTYPE_XXX */
  int bank;
  int address;
  int data_length;

  /* File Data */
  char file_path[1024];
  int file_mode;                 /* SAVEMEMORY_FILEMODE_XXX */
    
  /* Buffer */
  char buffer_log[BUFFER_SIZE];

  /* Liste chaine des Save Memory */
  struct window_savememory *next;
};

struct window_savememory *BuildSaveMemoryWindow(HINSTANCE,int);
void mem_free_window_savememory(struct window_savememory *);

/********************************************************/
