/**********************************************************************/
/*                                                                    */
/*   Window_Snapshot.h :  Header de gestion de la fentre Snapshot.   */
/*                                                                    */
/**********************************************************************/
/*  Auteur : Olivier ZARDINI  *  Brutal Deluxe  *  Date : Avril 2018  */
/**********************************************************************/

struct window_snapshot
{
  HWND hwnd_snapshot;

  /* ID du Menu */
  int menu_id;

  /** Surcharge des Control Edit **/
  WNDPROC oldEditProcProcA;
  WNDPROC oldEditProcProcX;
  WNDPROC oldEditProcProcY;
  WNDPROC oldEditProcProcDBR;
  WNDPROC oldEditProcProcPBR;
  WNDPROC oldEditProcProcPC;
  WNDPROC oldEditProcProcStack;
  WNDPROC oldEditProcProcDPage;
  WNDPROC oldEditProcStatusC;
  WNDPROC oldEditProcStatusZ;
  WNDPROC oldEditProcStatusI;
  WNDPROC oldEditProcStatusD;
  WNDPROC oldEditProcStatusX;
  WNDPROC oldEditProcStatusM;
  WNDPROC oldEditProcStatusV;
  WNDPROC oldEditProcStatusN;
  WNDPROC oldEditProcStatusE;
  WNDPROC oldEditProcStatusB;

  /* Snapshot charg en mmoire */
  struct snapshot *current_snapshot;
  
  /* Processor */
  WORD proc_a;
  WORD proc_x;
  WORD proc_y;
  BYTE proc_dbr;
  BYTE proc_pbr;
  WORD proc_pc;
  WORD proc_stack;
  WORD proc_directpage;

  /* Status Register */
  int status_c;
  int status_z;
  int status_i;
  int status_d;
  int status_x;
  int status_m;
  int status_v;
  int status_n;
  int status_e;
  int status_b;  

  /* RAM Size */
  int ram_size;       /* Nombre de bank mmoire en plus des 256 KB de base */

  /* ROM Type : Apple II ROM / Apple IIgs Rom 01 / Apple IIgs Rom 03 */
  int rom_type;

  /* Log du Process */
  char buffer_log[1024];
};

struct window_snapshot *BuildSnapshotWindow(HINSTANCE,int,char *);
void mem_free_window_snapshot(struct window_snapshot *);

/**********************************************************************/
