/************************************************************************/
/*                                                                      */
/*  Window_Softswitch.h :  Header de gestion de la fentre Softswitch.  */
/*                                                                      */
/************************************************************************/
/*  Auteur : Olivier ZARDINI  *   Brutal Deluxe   *   Date : Juin 2018  */
/************************************************************************/

/* Un message destin  la fentre Softswitch pour demander la maj de l'affichage */
#define HM_SOFTSWITCH_REFRESHWINDOW   (WM_USER + 23)
#define IDC_EDIT_SOFTSWITCH_DATA      1624

#define SOFTSWITCH_REFRESH_AUTOMATIC  0
#define SOFTSWITCH_REFRESH_MANUAL     1

#define SOFTSWITCH_EDIT_FONT_HEIGHT   14    /* Taille de la Fonte en Pixel */

struct window_softswitch
{
  HWND hwnd_softswitch;
  HWND hwnd_edit_data;          /* Control Text Multi Ligne */
  HFONT hFont;  
  
  /* Surchage des Control Edit pour rcuprer les vnements Souris */
  WNDPROC oldEditProcSoftswitchData;
  
  /* Mode de rafraichissement de la fentre */
  int refresh_mode;        /* SOFTSWITCH_REFRESH_XXX */

  /* Posiiton / Taille du Control Group Box */
  int group_data_x;
  int group_data_y;
  int group_data_width;
  int group_data_height;

  /* Position / Taille du Control Text Zone Softswitch Data */
  int softswitch_data_x;
  int softswitch_data_y;
  int softswitch_data_width;
  int softswitch_data_height;

  /** Control Edit : Zone Texte o sont affiches les Data **/  
  int nb_line;                     /* 16 */  
  int nb_column;                   /* 16 */
  int text_data_width;             /* "00/0000___00_00_00_00_00_00_00_00.00_00_00_00_00_00_00_00\r\n" */
  int text_data_size;              /* text_data_width*column */
  char *text_data_hexadecimal;     /* Zone Texte column*line */ 

  /** Donne actuellement affiche **/
  int softswitch_address;
  unsigned char softswitch_data[256];

  /* Dimension de la fentre = Title + Zone Texte */
  int title_height;
  int window_width;
  int window_height;
  
  /* Buffer */
  char buffer_log[BUFFER_SIZE];
  
  /* Notification */
  struct notification *current_notification;
};

struct window_softswitch *BuildSoftswitchWindow(HINSTANCE,int);
void mem_free_window_softswitch(struct window_softswitch *);

/********************************************************/
