/********************************************************************/
/*                                                                  */
/*  Window_Stack.h :  Header de gestion de la fentre Stack.        */
/*                                                                  */
/********************************************************************/
/*  Auteur : Olivier ZARDINI  *  Brutal Deluxe  *  Date : Mai 2018  */
/********************************************************************/

/* Un message destin  la fentre Stack pour demander la maj de l'affichage */
#define HM_STACK_REFRESHWINDOW      (WM_USER + 21)
#define IDC_RICHEDIT_STACK_DATA     1622

#define STACK_REFRESH_AUTOMATIC     0
#define STACK_REFRESH_MANUAL        1

#define STACK_POINTER_COLOR         MAKECOLOR(255,33,221)

#define STACK_RICHEDIT_FONT_HEIGHT     14    /* Taille de la Fonte en Pixel */
#define STACK_RICHEDIT_FONT_HEIGHT_RTF "16"  /* Taille de la Fonte dans le RTF */

struct window_stack
{
  HWND hwnd_stack;
  HWND hwnd_richedit_data;
  
  /* Mode de rafraichissement de la fentre */
  int refresh_mode;        /* STACK_REFRESH_XXX */

  /* Posiiton / Taille du Control Group Box */
  int group_data_x;
  int group_data_y;
  int group_data_width;
  int group_data_height;

  /* Position / Taille du Control Text Zone Stack Data */
  int stack_data_x;
  int stack_data_y;
  int stack_data_width;
  int stack_data_height;

  /** Control Edit : Zone Texte o sont affiches les Data **/  
  int nb_line;                     /* 16 */  
  int nb_column;                   /* 16 */
  int text_data_width;             /* "00/0000___00_00_00_00_00_00_00_00.00_00_00_00_00_00_00_00\r\n" */
  int rtf_data_size;               /* Taille de la Zone Texte RTF */
  char *rtf_data_hexadecimal;      /* Zone Texte RTF */  
  int rtf_write_offset;            /* Offset de l'criture de la Zone Texte RTF vers le Rich Edit */

  /** Donne actuellement affiche **/
  int stack_address;
  int stack_data_base_address;
  unsigned char stack_data[256];

  /* Dimension de la fentre = Title + Zone Texte */
  int title_height;
  int window_width;
  int window_height;
  
  /* Buffer */
  char buffer_log[BUFFER_SIZE];
  
  /* Notification */
  struct notification *current_notification;
};

struct window_stack *BuildStackWindow(HINSTANCE,int);
void mem_free_window_stack(struct window_stack *);

/********************************************************/
