/****************************************************************************/
/*                                                                          */
/*  Window_SymbolPickup.h :  Header de gestion de la fentre SymbolPickup.  */
/*                                                                          */
/****************************************************************************/
/*  Auteur : Olivier ZARDINI    *    Brutal Deluxe    *    Date : Jun 2024  */
/****************************************************************************/

#define SYMBOL_PICKUP_LISTVIEW_ROW_HEIGHT    15    /* Taille d'une ligne de la ListView (en Pixel) */

#define IDC_LISTVIEW_SYMBOL_PICKUP         1033

#define SYMBOL_PICKUP_LISTVIEW_NB_ROW        20    /* Nombre de ligne de donnes dans la ListView  */
#define SYMBOL_PICKUP_LISTVIEW_MIN_NB_ROW     2    /* Nombre de ligne de donnes Min dans la ListView  */

struct window_symbol_pickup
{
  HWND hwnd_symbol_pickup;
  HWND hwnd_parent;                            /* Fentre Pre (pour grer le MODAL) */
  HFONT hFont;
  int refresh_message_id;                      /* ID du message permettant de MAJ la fentre parent */

  /* Mode de retaille de la fentre (user/executable) */
  int user_resize;

  /* Dimension de la fentre  la cration */
  int window_init_width;
  int window_init_height;
  int nb_init_data_row;

  /* List View */
  int nb_row;                      /* Nombre de lignes affiches dans la ListBox */
  int symbol_x0;
  int symbol_y0;
  struct list_view listview_symbol_pickup;
  
  /* Symbol slectionn */
  DWORD symbol_address;
  int symbol_size;
  char symbol_name[1024];
  char symbol_segment[1024];
  char symbol_file[1024];

  /* Buffer */
  char buffer_log[BUFFER_SIZE];  
};

struct window_symbol_pickup *BuildSymbolPickupWindow(HINSTANCE,HWND,int);
void mem_free_window_symbol_pickup(struct window_symbol_pickup *);

/********************************************************/
