/************************************************************************/
/*                                                                      */
/*  Window_TextPage40.h :  Header de gestion de la fentre TextPage40.  */
/*                                                                      */
/************************************************************************/
/*  Auteur : Olivier ZARDINI  *   Brutal Deluxe   *   Date : Juin 2018  */
/************************************************************************/

/* Un message destin  la fentre Text Page 40 pour demander la maj de l'affichage */
#define HM_TEXTPAGE40_REFRESHWINDOW               (WM_USER + 24)
#define IDC_COMBOBOX_TEXTPAGE40_COLOR_TEXT        1625
#define IDC_COMBOBOX_TEXTPAGE40_COLOR_BACKGROUND  1626
#define IDC_COMBOBOX_TEXTPAGE40_DISPLAY_LANGUAGE  1627

#define TEXTPAGE40_REFRESH_AUTOMATIC  0
#define TEXTPAGE40_REFRESH_MANUAL     1

#define TEXTPAGE40_ZOOM_X1            1
#define TEXTPAGE40_ZOOM_X2            2
#define TEXTPAGE40_ZOOM_X3            3

#define TEXTPAGE40_EDIT_FONT_HEIGHT   14    /* Taille de la Fonte en Pixel */

#define TEXTPAGE40_DIALOGBOX_WIDTH    417   /* Largeur minimale en Pixel de la fentre */

struct window_textpage40
{
  HWND hwnd_textpage40;
  HWND hwnd_combo_color_text;         /* ComboBox pour le Color Text */
  HWND hwnd_combo_color_background;   /* ComboBox pour le Color Background */
  HWND hwnd_combo_display_language;   /* ComboBox pour le Display Language */
  HFONT hFont;

  DWORD thread_id;              /* Le ThreadID va permettre de diffrencier les diffrentes fentres */

  /** Graphical element attributes **/
  HDC hDC;
  HDC hCompatibleDC;
  HBITMAP hBitmap_textpage40;    /* Bitmap affchant la zone de slecion */
  DWORD *bitmap_data_textpage40;

  /* Surchage des Control Edit pour rcuprer les vnements Souris + Entre */
  WNDPROC oldEditProcBank;
  WNDPROC oldEditProcAddress;

  /* Mode de rafraichissement de la fentre */
  int refresh_mode;        /* TEXTPAGE40_REFRESH_XXX */

  /* Couleur */
  int color_text;
  int color_background;
  
  /* Flash Character */
  int flash;
  
  /* Language */
  int display_language;

  /* Zoom Level */
  int zoom_level;

  /* Posiiton / Taille du Control Group Box */
  int group_data_x;
  int group_data_y;
  int group_data_width;
  int group_data_height;

  /* Position / Taille de la Bitmap TextPage40 Data */
  int bitmap_textpage40_x;
  int bitmap_textpage40_y;
  int bitmap_textpage40_width;   /* 280 */
  int bitmap_textpage40_height;  /* 192 */

  /** Donnes actuellement affiches **/
  int textpage40_bank;
  int textpage40_address;
  unsigned char textpage40_data[40*24];
  int has_flash_character;

  /* Dimension de la fentre = Title + Zone Texte */
  int title_height;
  int window_width;
  int window_height;

  /* Buffer */
  char buffer_log[BUFFER_SIZE];

  /* Notification */
  struct notification *current_notification;

  /* Liste chaine des Text Page 40 */
  struct window_textpage40 *next;
};

struct window_textpage40 *BuildTextPage40Window(HINSTANCE,int);
void mem_free_window_textpage40(struct window_textpage40 *);

/********************************************************/
