/************************************************************************/
/*                                                                      */
/*  Window_TextPage80.h :  Header de gestion de la fentre TextPage80.  */
/*                                                                      */
/************************************************************************/
/*  Auteur : Olivier ZARDINI  *  Brutal Deluxe  *  Date : Juillet 2018  */
/************************************************************************/

/* Un message destin  la fentre Text Page 80 pour demander la maj de l'affichage */
#define HM_TEXTPAGE80_REFRESHWINDOW               (WM_USER + 25)
#define IDC_COMBOBOX_TEXTPAGE80_COLOR_TEXT        1628
#define IDC_COMBOBOX_TEXTPAGE80_COLOR_BACKGROUND  1629
#define IDC_COMBOBOX_TEXTPAGE80_DISPLAY_LANGUAGE  1630

#define TEXTPAGE80_REFRESH_AUTOMATIC  0
#define TEXTPAGE80_REFRESH_MANUAL     1

#define TEXTPAGE80_ZOOM_X1            1
#define TEXTPAGE80_ZOOM_X2            2

#define TEXTPAGE80_EDIT_FONT_HEIGHT   14    /* Taille de la Fonte en Pixel */

#define TEXTPAGE80_DIALOGBOX_WIDTH    417   /* Largeur minimale en Pixel de la fentre */

struct window_textpage80
{
  HWND hwnd_textpage80;
  HWND hwnd_combo_color_text;         /* ComboBox pour le Color Text */
  HWND hwnd_combo_color_background;   /* ComboBox pour le Color Background */
  HWND hwnd_combo_display_language;   /* ComboBox pour le Display Language */
  HFONT hFont;

  DWORD thread_id;              /* Le ThreadID va permettre de diffrencier les diffrentes fentres */

  /** Graphical element attributes **/
  HDC hDC;
  HDC hCompatibleDC;
  HBITMAP hBitmap_textpage80;    /* Bitmap affchant la zone de slecion */
  DWORD *bitmap_data_textpage80;

  /* Surchage des Control Edit pour rcuprer les vnements Souris + Entre */
  WNDPROC oldEditProcBank;
  WNDPROC oldEditProcAddress;

  /* Mode de rafraichissement de la fentre */
  int refresh_mode;        /* TEXTPAGE80_REFRESH_XXX */

  /* Couleur */
  int color_text;
  int color_background;
  
  /* Language */
  int display_language;

  /* Zoom Level */
  int zoom_level;

  /* Posiiton / Taille du Control Group Box */
  int group_data_x;
  int group_data_y;
  int group_data_width;
  int group_data_height;

  /* Position / Taille de la Bitmap TextPage80 Data */
  int bitmap_textpage80_x;
  int bitmap_textpage80_y;
  int bitmap_textpage80_width;   /* 560 */
  int bitmap_textpage80_height;  /* 192 */

  /** Donnes actuellement affiches **/
  int textpage80_bank;
  int textpage80_address;
  unsigned char textpage80_data[80*24];

  /* Dimension de la fentre = Title + Zone Texte */
  int title_height;
  int window_width;
  int window_height;

  /* Buffer */
  char buffer_log[BUFFER_SIZE];

  /* Notification */
  struct notification *current_notification;

  /* Liste chaine des Text Page 80 */
  struct window_textpage80 *next;
};

struct window_textpage80 *BuildTextPage80Window(HINSTANCE,int);
void mem_free_window_textpage80(struct window_textpage80 *);

/********************************************************/
