/********************************************************************/
/*                                                                  */
/*   Cyrene_Shared.h :  Header de gestion des fonctions partages.  */
/*                                                                  */
/********************************************************************/
/*  Auteur : Olivier ZARDINI  *  Brutal Deluxe  *  Date : May 2023  */
/********************************************************************/

#define BUFFER_SIZE                          2048

#define RAMTYPE_RAM                             1   /* RAM / ROM : 00/0000 - FF/FFFF */
#define RAMTYPE_DOC                             2   /* DOC RAM   : 0000 - FFFF */

void SetMemoryData(int,DWORD,DWORD,unsigned char *,struct cyrene_parameter *);
DWORD GetMemoryValue(DWORD,int,struct cyrene_operation *,struct cyrene_parameter *);
BYTE GetMemoryByte(DWORD,struct cyrene_operation *,struct cyrene_parameter *);
void SetMemoryByte(DWORD,BYTE,struct cyrene_parameter *);
void GetNamedValueText(char *,char *,char *);
int RefreshEmulatorWindows(struct cyrene_parameter *);
int GetNamedValueInt(char *,char *);
BYTE EvaluateAsOneByte(char *,int *);
BYTE EvaluateAsByte(char *,int *);
WORD EvaluateAsWord(char *,int *);
int IsHexaDecimal(char *,int *);
int IsHexaDecimalChar(char);
char **BuildUniqueListFromText(char *,char,int *);
void CleanBuffer(char *);
char *my_stristr(char *,char *);
char *GetCurrentTimeMS(void);
void mem_free_list(int,char **);
void LogTextLineDirect(char *,char *,int);

/********************************************************************/
